{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

{
  This units contains Operation Definition Records for
  some elementary arithmetic, string handling, 
  date-time manipulation and logical functions
}

unit Baseop;
{$I ..\alldemo.inc}

interface
USES Windows,Sysutils,
     PARSEH;


Procedure RegisterBaseOpNEXT(var ListRoot: pexProcRec);
{ Links all operation definition records via NEXT field.
  This chain is used by exparse DLL routines }
Procedure RegisterBaseOpUSER(var ListRoot: pexProcRec; VAR Total: longint);
{ Links all operation definition records via USERPTR field.
  This chain is used by demo applications }


implementation

CONST
{$I OP_HCTX.INC}

Var
  HLPFILE :  array [0..20] of Char = 'BASEOP.HLP';

                                                  {1234567890123456789012345}
  ClassIdbasicAritOper :  array [0..20] of Char = 'Arithmetic functions';
  ClassIdbasicStrOper  :  array [0..14] of Char=  'Text functions';
  ClassIdbasicDateOper :  array [0..14] of Char = 'Date functions';
  ClassIdRelatOper     :  array [0..20] of Char = 'Comparison operators';
  ClassIdLogicalOper   :  array [0..17] of Char = 'Boolean operators';
  ClassIdSelectOper    :  array [0..11] of Char = 'IF function';


  IDplus  : array [0..1] of Char = '+'; { Numbers and strings, number + date, date + number }
  IDminus : array [0..1] of Char = '-'; { Numbers , date - number }
  IDkrat  : array [0..1] of Char = '*'; { Numbers }
  IDdivide: array [0..1] of Char = '/'; { Numbers }

{ Identifiers in Operation registration records must be all uppercase }

  IDSqr   : array [0..3] of Char = 'SQR';  { 2nd power }
  IDSqrt  : array [0..4] of Char = 'SQRT'; { square root }

  IDAbs         : array [0..3] of Char = 'ABS';
  IDARIT_MIN    : array [0..3] of Char = 'MIN';
  IDARIT_MAX    : array [0..3] of Char = 'MAX';
  IDARIT_MOD    : array [0..3] of Char = 'MOD';
  IDARIT_DIV    : array [0..3] of Char = 'DIV';
  IDARIT_ROUND  : array [0..5] of Char = 'ROUND'; { ROUND(number,Decpl),  supports negative Decpl }
{ All type comparison }
  IDEq    : array [0..1] of Char ='=';
  IDLess  : array [0..1] of Char ='<';
  IDMore  : array [0..1] of Char ='>';
  IDLessEq: array [0..2] of Char ='<=';
  IDMoreEq: array [0..2] of Char ='>=';
  IDnotEq : array [0..2] of Char ='<>';
{ Boolean functions }
  IDNot   : array [0..3] of Char ='NOT';
  IDAnd   : array [0..3] of Char ='AND';
  IDOr    : array [0..2] of Char ='OR';
{ Number_2_string : }
  IDNumS  : array [0..4] of Char ='NUM$';
      { NUM$(Fmt: Integer, dPl: Integer, x: number): String
        where Fmt: 0 - Fixed
                   1 - Scientific
                   2 - Standard
                   3 - Currency
                   4 - Percentage
              DPl: number of decimal places
               x : number
       }
  IDStrS   : array [0..4] of Char ='STR$';  { all types -> string }
  IDStr    : array [0..3] of Char ='STR';   { (number,Len,Decpl) -> string }
  IDUpper  : array [0..5] of Char ='UPPER'; { String -> string }
  IDPos    : array [0..3] of Char ='POS';   { <G> }
  IDCopy   : array [0..4] of Char ='COPY';  { dtto }
  IdLength : array [0..3] of Char ='LEN';   { = Length }
  IDToday   : array [0..5] of Char ='TODAY'; { Current date }
  IdDatYear: array [0..4] of Char ='YEAR'; { (Date) -> Year of datetime }
  IdDatMnth: array [0..5] of Char ='MONTH';{ (Date) -> Month of datetime }
  IdDatday : array [0..3] of Char ='DAY';   { (Date) -> Day of datetime }

  IdIF     : array [0..2] of Char = 'IF'; {IF(logical_test, value_if_true, value_if_false)}

  IdDayofWeek : array [0..9] of Char ='DAYOFWEEK';    { (date), returns day of week }
  IdDate      : array [0..4] of Char ='DATE';         { (day,Mnth,Year) , returns date }
  IdMonthName : array [0..9] of Char ='MONTHTEXT';    { (day_number) returns the name of the day of week}
  IdDayname   : array [0..7] of Char ='DAYTEXT';      { (Month_number) returns long name of the month }

function Exp10(x: exNumber):exNumber;
begin
  Exp10:=Exp(x*2.30258509299405);
end;


{=========================================================================================}
Function OperIDplus(prec: pexProcRec; Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
var XOp1,XOp2: variant;
begin     
  if VarIsNull(Op1) then XOp1 := 0 else XOp1 := Op1;
  if VarIsNull(Op2) then XOp2 := 0 else XOp2 := Op2;
  result := XOp1 + XOp2
end;
Function OperIDminus(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
var XOp1,XOp2: variant;
begin
  if varIsNull(Op1) then XOp1 := 0 else XOp1 := Op1;
  if varIsNull(Op2) then XOp2 := 0 else XOp2 := Op2;
  result := XOp1 - XOp2
end;
Function OperIDNumer2(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
VAR
  x,
  y,
  Z: exNumber;
  U,IntP,DecP: exNumber;
begin
  X := Op1;
  Y := Op2;
  z := 0;
  if pRec.pIdentif = IDKrat then z := x*y
  else if pRec.pIdentif = IDDivide then z := x/y
  else if pRec.pIdentif =  IDARIT_MIN then begin
     if x < y then Z := x else Z := y
  end
  else if pRec.pIdentif =IDARIT_MAX then begin
    if x > y then Z := x else Z := y
  end
  else if pRec.pIdentif =IDARIT_ROUND then begin
    if y = 0 then Z := Round(x) else begin
      IntP := Trunc(x);
      DecP := Frac(x);
      U := Exp10(y);
      if y > 0 then
        Z := IntP + round(DecP*U)/U
      else
        Z := round(U*x)/U
    end
  end else if pRec.pIdentif =IDARIT_MOD      then begin
    U := x/y;
    Z := x - y*Trunc(U)
  end else if pRec.pIdentif =IDARIT_DIV      then begin
    U := x/y;
    Z := Trunc(U);
  end;
  Result := Z;
end;

Function OperIDNumer1(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
Var X,Z: exNumber;
begin
  X := Op1;
  Z := 0;
  if pRec.pIdentif = IDMinus then
     Z := -X
  else if pRec.pIdentif = IDSQR then
     Z := SQR(X)
  else if pRec.pIdentif = IDSQRT then
     Z := SQRT(X)
  else if pRec.pIdentif = IDABS then
     Z := ABS(X);
  Result := Z;
end;

Function OperID_STR(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2,op3: variant):variant; stdcall;
Var x: Extended;
    y,z: exNumber;
    iY,iZ: Longint;
begin
  x := Op1;
  y := Op2; iy := trunc(y);
  z := Op3; iz := trunc(z);
{  Str(x:Trunc(y):Trunc(z), S);}
  Result := FloatToStrF(x,ffNumber,iy,iz);
  if length(Result) < iy then Result := StringOfChar(' ',iy-length(Result))+Result;
end;

Function OperID_STRS(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
Var s : exString;
begin
  S := VarToStr(op1);
  Result := s;
end;

Function OperCompare(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
Var S1,S2: exString;
    IsStr: exBool;
begin
  if (varType(Op1) = varString) and (varType(Op2)=varString) then begin
    IsStr := True;
    S1 := Op1; S2 := Op2;
  end else IsStr := false;
  if pRec.pIdentif = IdEq then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) = 0
     else Result := Op1 = Op2
  end
  else if pRec.pIdentif = IdLess then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) <  0
     else Result := Op1 < Op2
  end
  else if pRec.pIdentif = IdMore then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) >  0
     else Result := Op1 > Op2
  end
  else if pRec.pIdentif = IdLessEq then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) <=  0
     else Result := Op1 <= Op2
  end
  else if pRec.pIdentif = IdMoreEq then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) >=  0
     else Result := Op1 >= Op2
  end
  else if pRec.pIdentif = IdNotEq then begin
     if IsStr then Result := exprCompareText(ExprHandle,S1,S2) <>  0
     else Result := Op1 <> Op2
  end
end;
Function OperIDNot(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: Variant):variant; stdcall;
begin
  Result := not Op1
end;
Function OperIDAndOR(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
begin
  if pRec.pIdentif = IDAnd then
    Result := Op1 and Op2
  else if pRec.pIdentif = IDOR then
    Result := Op1 OR Op2
end;
Function OperIDUpperLength(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
Var S: exString;
    X : exNumber;
begin
  S := VarToStr(Op1);
  if pRec.pIdentif = IDUpper then
    Result := AnsiUppercase(S)
  else if pRec.pIdentif = IDLength then begin
    X := Length(S);
    Result := X; { Cislo se musi vzdy vracet jako double }
  end
end;

Function OperIDPos(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2: variant):variant; stdcall;
Var S1,S2: exString; X: exNumber;
begin
  S1 := VarToStr(Op1);
  S2 := VarToStr(Op2);
  X := POS(S1,S2);
  Result := X;
end;

Function OperIDCopy(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2,op3: variant):variant; stdcall;
var S: exString;
    X,Y: exNumber;
begin
  S := varToStr(Op1);
  X := Op2; Y := Op3;
  Result := copy(S,Trunc(X),Trunc(Y))
end;

Function OperIDToday(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer):variant; stdcall;
Var X: exDate;
begin
  X := Trunc(Now);
  Result := X;
end;

Function OperIdDatYearMnthday(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
VAR
  Rok,Mnth,day,Hour,Min,Sec,MSec:Word;
  XRok,XMnth,Xday:exNumber;
  X: exDate;
begin
  X := varTodateTime(Op1);
  Decodedate(X,Rok,Mnth,day);
  DecodeTime(X,Hour,Min,Sec,Msec);
  XRok := Rok;
  XMnth := Mnth;
  Xday := day;
  if pRec.pIdentif = IDDatYear then Result := XRok
  else
  if pRec.pIdentif = IDdatMnth then Result := XMnth
  else
  if pRec.pIdentif = IDDatday then Result := Xday
end;

Function OperIdIF(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2,op3: variant):variant; stdcall;
begin
  if Op1 then Result := Op2 else Result := Op3;
end;

Function OperIdNumS(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2,op3: variant):variant; stdcall;
Var Num : Extended;
    dPl : Integer;
    nFmt: Integer;
    S: String;
begin
 Num  := Op3;
 dPl  := Op2;
 nFmt := Op1;
 Case nFmt of
 0: {nfFixed }  S := 'f';
 1: {nfScientific} begin
                 S := 'e';
                 Inc(DPl)
               end;
 2:{nfStandard}   S := 'n';
 3:{nfCurrency}   S := 'm';
 4:{nfPercentage} begin
                  S := 'f';
                  Num := 100*Num
                end;
 end;
 S := '.'+IntToStr(Dpl)+S;
 S := Format('%'+S,[Num]);
 if nFmt=4{nfPercentage} then S := S + '%';
 Result := S;
end;


Function OperIdDayofWeek(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
var d: tdatetime;
    i: integer;
begin
  d := Op1;
  i := DayOfWeek(d);
  Result := i;
end;
Function OperIdDate(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1,op2,op3: variant):variant; stdcall;
var d,m,y: integer;
    dat: tdatetime;
begin
  d := op1;
  m := op2;
  y := op3;
  dat := encodedate(y,m,d);
  Result := dat;
end;
Function OperIdDateName(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer; Const op1: variant):variant; stdcall;
var i: integer;
begin
  Result := null;
  i := op1;
  if pRec.pIdentif = IdMonthName then begin
    if ( i >= 1) and (i <= 12) then Result := longmonthnames[i];
  end else
  if pRec.pIdentif = IdDayname then begin
    if ( i >= 1) and (i <= 7) then Result := longdaynames[i];
  end
end;


VAR

 RIDplusA: texProcRec=(
            PIdentif :@IDPlus;
             attrib  :3;
             procAddr  :@OperIDPlus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_PLUS;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDplusB: texProcRec=(
            PIdentif :@IDPlus;
             attrib  :3;
             procAddr  :@OperIDPlus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_PLUS;
             aResult  :ext_Date;
             Param1   :ext_Number;
             Param2   :ext_Date);
 RIDplusC: texProcRec=(
            PIdentif :@IDPlus;
             attrib  :3;
             procAddr  :@OperIDPlus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_PLUS;
             aResult  :ext_Date;
             Param1   :ext_Date;
             Param2   :ext_Number);
 RIDplusD: texProcRec=(
            PIdentif :@IDPlus;
             attrib  :3;
             procAddr  :@OperIDPlus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_PLUS;
             aResult  :ext_String;
             Param1   :ext_String;
             Param2   :ext_String);
 RIDminus0:texProcRec=(
             PIdentif :@IDMinus;
             attrib  :1;
             procAddr  :@OperIDNumer1;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MINUS;
             aResult  :ext_Number;
             Param1   :ext_Number);
 RIDminus1  :texProcRec=(
             PIdentif :@IDMinus;
             attrib  :3;
             procAddr  :@OperIDMinus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MINUS;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDminus2 :texProcRec=(
             PIdentif :@IDMinus;
             attrib  :3;
             procAddr  :@OperIDMinus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MINUS;
             aResult  :ext_Date;
             Param1   :ext_Date;
             Param2   :ext_Number);
 RIDminus3 :texProcRec=(
             PIdentif :@IDMinus;
             attrib  :3;
             procAddr  :@OperIDMinus;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MINUS;
             aResult  :ext_Number;
             Param1   :ext_Date;
             Param2   :ext_Date);
 RIDtimes :texProcRec=(
             PIdentif :@IDkrat;
             attrib  :2;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MULTIPLE;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDDivide:texProcRec=(
             PIdentif :@IDDivide;
             attrib  :2;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DIVISION;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDARIT_MIN:texProcRec=(
             PIdentif :@IDARIT_MIN;
             attrib  :0;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MIN;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDARIT_MAX:texProcRec=(
             PIdentif :@IDARIT_MAX;
             attrib  :0;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MAX;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDARIT_MOD:texProcRec=(
             PIdentif :@IDARIT_MOD;
             attrib  :2;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MOD;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDARIT_DIV:texProcRec=(
             PIdentif :@IDARIT_DIV;
             attrib  :2;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DIV;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDARIT_ROUND:texProcRec=(
             PIdentif :@IDARIT_ROUND;
             attrib  :0;
             procAddr  :@OperIDNumer2;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_ROUND;
             aResult  :ext_Number;
             Param1   :ext_Number;
             Param2   :ext_Number);
 RIDSqr:texProcRec=(
             PIdentif :@IDSqr;
             attrib  :0;
             procAddr  :@OperIDNumer1;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_SQR;
             aResult  :ext_Number;
             Param1   :ext_Number);
 RIDSqrt:texProcRec=(
             PIdentif :@IDSqrt;
             attrib  :0;
             procAddr  :@OperIDNumer1;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_SQRT;
             aResult  :ext_Number;
             Param1   :ext_Number);
 RIDAbs:texProcRec=(
             PIdentif :@IDABS;
             attrib  :0;
             procAddr  :@OperIDNumer1;
             ClassIdentif : @ClassIdbasicAritOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_ABS;
             aResult  :ext_Number;
             Param1   :ext_Number);
 RIDEq1 :texProcRec=(
             PIdentif :@IDEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDEq2 :texProcRec=(
             PIdentif :@IDEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDEq3 :texProcRec=(
             PIdentif :@IDEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDEq4 :texProcRec=(
             PIdentif :@IDEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDLess1 :texProcRec=(
             PIdentif :@IDLess;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDLess2 :texProcRec=(
             PIdentif :@IDLess;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDLess3 :texProcRec=(
             PIdentif :@IDLess;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDLess4 :texProcRec=(
             PIdentif :@IDLess;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDMore1 :texProcRec=(
             PIdentif :@IDMore;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDMore2 :texProcRec=(
             PIdentif :@IDMore;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDMore3 :texProcRec=(
             PIdentif :@IDMore;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDMore4 :texProcRec=(
             PIdentif :@IDMore;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDLessEq1 :texProcRec=(
             PIdentif :@IDLessEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDLessEq2 :texProcRec=(
             PIdentif :@IDLessEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDLessEq3 :texProcRec=(
             PIdentif :@IDLessEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDLessEq4 :texProcRec=(
             PIdentif :@IDLessEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDMoreEq1 :texProcRec=(
             PIdentif :@IDMoreEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDMoreEq2 :texProcRec=(
             PIdentif :@IDMoreEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDMoreEq3 :texProcRec=(
             PIdentif :@IDMoreEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDMoreEq4 :texProcRec=(
             PIdentif :@IDMoreEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDNotEq1 :texProcRec=(
             PIdentif :@IDNotEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Number;
             Param2  :ext_Number);
 RIDNotEq2 :texProcRec=(
             PIdentif :@IDNotEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDNotEq3 :texProcRec=(
             PIdentif :@IDNotEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDNotEq4 :texProcRec=(
             PIdentif :@IDNotEq;
             attrib:4;
             procAddr :@OperCompare;
             ClassIdentif : @ClassIdRelatOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COMPARE;
             aResult :ext_Bool;
             Param1  :ext_Date;
             Param2  :ext_Date);
 RIDNot :texProcRec=(
             PIdentif :@IDNot;
             attrib:1;
             procAddr :@OperIDNot;
             ClassIdentif : @ClassIdLogicalOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_NOT;
             aResult  :ext_Bool;
             Param1  :ext_Bool);
 RIDAnd:texProcRec=(
             PIdentif :@IDAND;
             attrib:3;
             procAddr :@OperIDAndOR;
             ClassIdentif : @ClassIdLogicalOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_AND;
             aResult  :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDOr:texProcRec=(
             PIdentif :@IDOR;
             attrib:3;
             procAddr :@OperIDAndOR;
             ClassIdentif : @ClassIdLogicalOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_OR;
             aResult  :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool);
 RIDStr :texProcRec=(
             PIdentif :@IDStr;
             attrib:0;
             procAddr :@OperID_Str;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_STR;
             aResult  :ext_String;
             Param1  :ext_Number;
             Param2  :ext_Number;
             Param3  :ext_Number);
 RIDNumS :texProcRec=(
             PIdentif :@IDNumS;
             attrib:0;
             procAddr :@OperIDNumS;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_NUMS;
             aResult  :ext_String;
             Param1  :ext_Number;
             Param2  :ext_Number;
             Param3  :ext_Number);
 RIDStrSA :texProcRec=(
             PIdentif :@IDStrS;
             attrib:0;
             procAddr :@OperID_StrS;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_STRS;
             aResult  :ext_String;
             Param1   :ext_Number);
 RIDStrSB :texProcRec=(
             PIdentif :@IDStrS;
             attrib:0;
             procAddr :@OperID_StrS;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_STRS;
             aResult  :ext_String;
             Param1   :ext_String);
 RIDStrSC :texProcRec=(
             PIdentif :@IDStrS;
             attrib:0;
             procAddr :@OperID_StrS;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_STRS;
             aResult  :ext_String;
             Param1   :ext_Date);
 RIDStrSD :texProcRec=(
             PIdentif :@IDStrS;
             attrib:0;
             procAddr :@OperID_StrS;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_STRS;
             aResult  :ext_String;
             Param1   :ext_Bool);
 RIDUpper :texProcRec=(
             PIdentif :@IDUpper;
             attrib:0;
             procAddr :@OperIDUpperlength;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_UPPER;
             aResult  :ext_String;
             Param1  :ext_String);
 RIDLength:texProcRec=(
             PIdentif :@IDlength;
             attrib:0;
             procAddr :@OperIDUpperlength;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_LEN;
             aResult  :ext_Number;
             Param1  :ext_String);
 RIDPos  :texProcRec=(
             PIdentif :@IDPos;
             attrib:0;
             procAddr :@OperIDPos;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_POS;
             aResult :ext_Number;
             Param1  :ext_String;
             Param2  :ext_String);
 RIDCopy   :texProcRec=(
             PIdentif :@IDCopy;
             attrib:0;
             procAddr :@OperIDCopy;
             ClassIdentif : @ClassIdBasicStrOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_COPY;
             aResult :ext_String;
             Param1  :ext_String;
             Param2  :ext_Number;
             Param3  :ext_Number);
 RIDToday  :texProcRec=(
             PIdentif :@IDToday;
             attrib:0;
             procAddr :@OperIDToday;
             ClassIdentif : @ClassIdBasicdateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_TODAY;
             aResult  :ext_Date);
 RIDDatYear :texProcRec=(
             PIdentif :@IDDatYear;
             attrib:0;
             procAddr :@OperIDDatYearMnthday;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_YEAR;
             aResult :ext_Number;
             Param1  :ext_Date);
 RIDDatMnth:texProcRec=(
             PIdentif :@IDDatMnth;
             attrib:0;
             procAddr :@OperIDDatYearMnthday;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_MONTH;
             aResult :ext_Number;
             Param1  :ext_Date);
 RIDDatday:texProcRec=(
             PIdentif :@IDDatday;
             attrib:0;
             procAddr :@OperIDDatYearMnthday;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DAY;
             aResult :ext_Number;
             Param1  :ext_Date);
 RIDifA  :texProcRec=(
             PIdentif :@IDIF;
             attrib:0;
             procAddr :@OperIDIf;
             ClassIdentif : @ClassIdSelectOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_IF;
             aResult :ext_Number;
             Param1  :ext_Bool;
             Param2  :ext_Number;
             Param3  :ext_Number);
 RIDifB  :texProcRec=(
             PIdentif :@IDIF;
             attrib:0;
             procAddr :@OperIDIf;
             ClassIdentif : @ClassIdSelectOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_IF;
             aResult :ext_String;
             Param1  :ext_Bool;
             Param2  :ext_String;
             Param3  :ext_String);
 RIDifC  :texProcRec=(
             PIdentif :@IDIF;
             attrib:0;
             procAddr :@OperIDIf;
             ClassIdentif : @ClassIdSelectOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_IF;
             aResult :ext_Date;
             Param1  :ext_Bool;
             Param2  :ext_Date;
             Param3  :ext_Date);
 RIDifD  :texProcRec=(
             PIdentif :@IDIF;
             attrib:0;
             procAddr :@OperIDIf;
             ClassIdentif : @ClassIdSelectOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_IF;
             aResult :ext_Bool;
             Param1  :ext_Bool;
             Param2  :ext_Bool;
             Param3  :ext_Bool);

{---------------}

 RIDdayOfWeek  :texProcRec=(
             PIdentif :@IdDayofWeek;
             attrib:0;
             procAddr :@OperIDDayofWeek;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DAYOFWEEK;
             aResult :ext_Number;
             Param1  :ext_Date);
 RIDDate  :texProcRec=(
             PIdentif :@IdDate;
             attrib:0;
             procAddr :@OperIDDate;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DATE;
             aResult :ext_Date;
             Param1  :ext_Number;
             Param2  :ext_Number;
             Param3  :ext_Number);
 RIDMonthname :texProcRec=(
             PIdentif :@IdMonthName;
             attrib:0;
             procAddr :@OperIDDatename;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DATENAME;
             aResult :ext_String;
             Param1  :ext_Number);
 RIDDayname  :texProcRec=(
             PIdentif :@IdDayName;
             attrib:0;
             procAddr :@OperIDDatename;
             ClassIdentif : @ClassIdBasicDateOper;
             HelpFilename : @HLPFILE;
             HelpContext  : OPER_ID_DATENAME;
             aResult :ext_String;
             Param1  :ext_Number);


Procedure RegisterBaseOpNEXT(var ListRoot: pexProcRec);
begin
  NEXTRegisterODR(ListRoot,@RIDplusA);
  NEXTRegisterODR(ListRoot,@RIDplusB);
  NEXTRegisterODR(ListRoot,@RIDplusC);
  NEXTRegisterODR(ListRoot,@RIDplusD);
  NEXTRegisterODR(ListRoot,@RIDminus0);
  NEXTRegisterODR(ListRoot,@RIDminus1 );
  NEXTRegisterODR(ListRoot,@RIDminus2);
  NEXTRegisterODR(ListRoot,@RIDminus3);
  NEXTRegisterODR(ListRoot,@RIDtimes);
  NEXTRegisterODR(ListRoot,@RIDDivide);
  NEXTRegisterODR(ListRoot,@RIDARIT_MIN);
  NEXTRegisterODR(ListRoot,@RIDARIT_MAX);
  NEXTRegisterODR(ListRoot,@RIDARIT_MOD);
  NEXTRegisterODR(ListRoot,@RIDARIT_DIV);
  NEXTRegisterODR(ListRoot,@RIDARIT_ROUND);
  NEXTRegisterODR(ListRoot,@RIDSqr);
  NEXTRegisterODR(ListRoot,@RIDSqrt);
  NEXTRegisterODR(ListRoot,@RIDAbs);
  NEXTRegisterODR(ListRoot,@RIDEq1);
  NEXTRegisterODR(ListRoot,@RIDEq2);
  NEXTRegisterODR(ListRoot,@RIDEq3);
  NEXTRegisterODR(ListRoot,@RIDEq4);
  NEXTRegisterODR(ListRoot,@RIDLess1);
  NEXTRegisterODR(ListRoot,@RIDLess2);
  NEXTRegisterODR(ListRoot,@RIDLess3);
  NEXTRegisterODR(ListRoot,@RIDLess4);
  NEXTRegisterODR(ListRoot,@RIDMore1);
  NEXTRegisterODR(ListRoot,@RIDMore2);
  NEXTRegisterODR(ListRoot,@RIDMore3);
  NEXTRegisterODR(ListRoot,@RIDMore4);
  NEXTRegisterODR(ListRoot,@RIDLessEq1);
  NEXTRegisterODR(ListRoot,@RIDLessEq2);
  NEXTRegisterODR(ListRoot,@RIDLessEq3);
  NEXTRegisterODR(ListRoot,@RIDLessEq4);
  NEXTRegisterODR(ListRoot,@RIDMoreEq1);
  NEXTRegisterODR(ListRoot,@RIDMoreEq2);
  NEXTRegisterODR(ListRoot,@RIDMoreEq3);
  NEXTRegisterODR(ListRoot,@RIDMoreEq4);
  NEXTRegisterODR(ListRoot,@RIDNotEq1);
  NEXTRegisterODR(ListRoot,@RIDNotEq2);
  NEXTRegisterODR(ListRoot,@RIDNotEq3);
  NEXTRegisterODR(ListRoot,@RIDNotEq4);
  NEXTRegisterODR(ListRoot,@RIDNot);
  NEXTRegisterODR(ListRoot,@RIDAnd);
  NEXTRegisterODR(ListRoot,@RIDOr);
  NEXTRegisterODR(ListRoot,@RIDNumS);
  NEXTRegisterODR(ListRoot,@RIDStr);
  NEXTRegisterODR(ListRoot,@RIDStrSA);
  NEXTRegisterODR(ListRoot,@RIDStrSB);
  NEXTRegisterODR(ListRoot,@RIDStrSC);
  NEXTRegisterODR(ListRoot,@RIDStrSD);
  NEXTRegisterODR(ListRoot,@RIDUpper);
  NEXTRegisterODR(ListRoot,@RIDLength);
  NEXTRegisterODR(ListRoot,@RIDPos );
  NEXTRegisterODR(ListRoot,@RIDCopy  );
  NEXTRegisterODR(ListRoot,@RIDToday );
  NEXTRegisterODR(ListRoot,@RIDDatYear);
  NEXTRegisterODR(ListRoot,@RIDDatMnth);
  NEXTRegisterODR(ListRoot,@RIDDatday);
  NEXTRegisterODR(ListRoot,@RIDifA);
  NEXTRegisterODR(ListRoot,@RIDifB);
  NEXTRegisterODR(ListRoot,@RIDifC);
  NEXTRegisterODR(ListRoot,@RIDifD);
  NEXTRegisterODR(ListRoot,@RIDdayOfWeek);
  NEXTRegisterODR(ListRoot,@RIDDate);
  NEXTRegisterODR(ListRoot,@RIDMonthname);
  NEXTRegisterODR(ListRoot,@RIDDayname);
end;

Procedure RegisterBaseOpUSER(var ListRoot: pexProcRec; VAR Total: longint);
begin
  UserRegisterODR(ListRoot,@RIDplusA,total);
  UserRegisterODR(ListRoot,@RIDplusB,total);
  UserRegisterODR(ListRoot,@RIDplusC,total);
  UserRegisterODR(ListRoot,@RIDplusD,total);
  UserRegisterODR(ListRoot,@RIDminus0,total);
  UserRegisterODR(ListRoot,@RIDminus1 ,total);
  UserRegisterODR(ListRoot,@RIDminus2,total);
  UserRegisterODR(ListRoot,@RIDminus3,total);
  UserRegisterODR(ListRoot,@RIDtimes,total);
  UserRegisterODR(ListRoot,@RIDDivide,total);
  UserRegisterODR(ListRoot,@RIDARIT_MIN,total);
  UserRegisterODR(ListRoot,@RIDARIT_MAX,total);
  UserRegisterODR(ListRoot,@RIDARIT_MOD,total);
  UserRegisterODR(ListRoot,@RIDARIT_DIV,total);
  UserRegisterODR(ListRoot,@RIDARIT_ROUND,total);
  UserRegisterODR(ListRoot,@RIDSqr,total);
  UserRegisterODR(ListRoot,@RIDSqrt,total);
  UserRegisterODR(ListRoot,@RIDAbs,total);
  UserRegisterODR(ListRoot,@RIDEq1,total);
  UserRegisterODR(ListRoot,@RIDEq2,total);
  UserRegisterODR(ListRoot,@RIDEq3,total);
  UserRegisterODR(ListRoot,@RIDEq4,total);
  UserRegisterODR(ListRoot,@RIDLess1,total);
  UserRegisterODR(ListRoot,@RIDLess2,total);
  UserRegisterODR(ListRoot,@RIDLess3,total);
  UserRegisterODR(ListRoot,@RIDLess4,total);
  UserRegisterODR(ListRoot,@RIDMore1,total);
  UserRegisterODR(ListRoot,@RIDMore2,total);
  UserRegisterODR(ListRoot,@RIDMore3,total);
  UserRegisterODR(ListRoot,@RIDMore4,total);
  UserRegisterODR(ListRoot,@RIDLessEq1,total);
  UserRegisterODR(ListRoot,@RIDLessEq2,total);
  UserRegisterODR(ListRoot,@RIDLessEq3,total);
  UserRegisterODR(ListRoot,@RIDLessEq4,total);
  UserRegisterODR(ListRoot,@RIDMoreEq1,total);
  UserRegisterODR(ListRoot,@RIDMoreEq2,total);
  UserRegisterODR(ListRoot,@RIDMoreEq3,total);
  UserRegisterODR(ListRoot,@RIDMoreEq4,total);
  UserRegisterODR(ListRoot,@RIDNotEq1,total);
  UserRegisterODR(ListRoot,@RIDNotEq2,total);
  UserRegisterODR(ListRoot,@RIDNotEq3,total);
  UserRegisterODR(ListRoot,@RIDNotEq4,total);
  UserRegisterODR(ListRoot,@RIDNot,total);
  UserRegisterODR(ListRoot,@RIDAnd,total);
  UserRegisterODR(ListRoot,@RIDOr,total);
  UserRegisterODR(ListRoot,@RIDNumS,total);
  UserRegisterODR(ListRoot,@RIDStr,total);
  UserRegisterODR(ListRoot,@RIDStrSA,total);
  UserRegisterODR(ListRoot,@RIDStrSB,total);
  UserRegisterODR(ListRoot,@RIDStrSC,total);
  UserRegisterODR(ListRoot,@RIDStrSD,total);
  UserRegisterODR(ListRoot,@RIDUpper,total);
  UserRegisterODR(ListRoot,@RIDLength,total);
  UserRegisterODR(ListRoot,@RIDPos ,total);
  UserRegisterODR(ListRoot,@RIDCopy  ,total);
  UserRegisterODR(ListRoot,@RIDToday ,total);
  UserRegisterODR(ListRoot,@RIDDatYear,total);
  UserRegisterODR(ListRoot,@RIDDatMnth,total);
  UserRegisterODR(ListRoot,@RIDDatday,total);
  UserRegisterODR(ListRoot,@RIDifA,total);
  UserRegisterODR(ListRoot,@RIDifB,total);
  UserRegisterODR(ListRoot,@RIDifC,total);
  UserRegisterODR(ListRoot,@RIDifD,total);
  UserRegisterODR(ListRoot,@RIDdayOfWeek,total);
  UserRegisterODR(ListRoot,@RIDDate,total);
  UserRegisterODR(ListRoot,@RIDMonthname,total);
  UserRegisterODR(ListRoot,@RIDDayname,total);
end;


END.




