{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

{
  This unit implements simple expression builder
}  


unit ExprBldr;
{$I ..\alldemo.inc}

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Dialogs,
  Buttons, ExtCtrls, Typinfo,
  PARSEH, EXPROBJ;



type
  TExpressionBuildDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    ClassIdBox: TListBox;
    IdentifBox: TListBox;
    Resultmemo: TMemo;
    UseItBtn: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    lpbutton: TButton;
    rpbutton: TButton;
    Button0: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    PeriodBtn: TButton;
    TestBtn: TButton;
    UvozovkyBtn: TButton;
    EqualButton: TButton;
    helpBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ClassIdBoxClick(Sender: TObject);
    procedure UseItBtnClick(Sender: TObject);
    procedure IdentifBoxDblClick(Sender: TObject);
    procedure ResultmemoExit(Sender: TObject);
    procedure ResultmemoEnter(Sender: TObject);
    procedure CaptionBtnClick(Sender: TObject);
    procedure IdentifBoxClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TestBtnClick(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
  private
    { Private declarations }
    ExpResults: texTypes;
    TestExpr  :tExpression;
    helpFile: pChar;
    InvokeHelpProc: Pointer;
    ListRoot : pexProcRec;
    OldOnIdle: tIdleEvent;
    Procedure BuildClassIdList(aList:tStrings);
    Procedure BuildIdentifList(aClassIdBox:tCustomListBox;IdentifList:tStrings);
    Procedure AddTomemo(Const S:String; amemo:tmemo);
    Procedure DlgUpdate;
    procedure SetItemhelp;
    procedure DoIdle(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

tOnInvokeHelp=procedure(lpHFname: pChar; HContext: word);

{ launces expression builder }
function _BuildExpr(Var S:String; // Expression string
                    RootAddr: pexProcRec; // Root of ODR linked list
                    ExpectedResults:texTypes;  // What types of result we need
                    OnInvokeHelp: Pointer):Boolean;  // What should be done when user press Help button

{ Invokes help with given helpfile and helpcontext }
Procedure InvokeBuilderHelp(lpHFname: pChar; HContext: word);

implementation  //Uses _Const,_WinUtil,_LibUtl1,_CtrlUtl;

{$R *.DFM}


procedure InvokeBuilderHelp(lpHFname: pChar; HContext: word);
var savhlpFile: string;
begin
  savhlpFile := application.helpfile;
  Try
    application.helpfile := lpHFname;
    Application.HelpContext(HContext);
  Finally
    application.helpfile := savhlpFile;
  End;
end;

function _BuildExpr(Var S:String;
                    RootAddr: pexProcRec;
                    ExpectedResults:texTypes;
                    OnInvokeHelp: Pointer):Boolean;
var
  ExpressionBuildDlg: TExpressionBuildDlg;
begin
  Result := false;
  ExpressionBuildDlg :=  tExpressionBuildDlg.Create(NIL);
  With ExpressionBuildDlg do Try
    OldOnIdle := Application.OnIdle;
    Application.OnIdle := DoIdle;
    ListRoot := RootAddr;
    ExpResults := ExpectedResults;
    TestExpr := tExpression.Create;
    BuildClassIdList(ClassIdBox.Items);
    DlgUpdate;
    Try
      InvokehelpProc := OnInvokeHelp;
      Resultmemo.Text := S;
      Resultmemo.SelectAll;
      if ShowModal = mrOK then begin
        S := Resultmemo.text;
        Result := True;
      end;
    Finally
      TestExpr.Free;
    End;
  Finally
    Application.OnIdle := OldOnIdle;
    Free;
  end;
end;

Procedure DrawPseudocaret(pcControl:tCustomEdit;StockBrush:Integer);
var CP: tPoint;
    aDC:HDC;
    aBrush: hBrush;
    R: tRect;
    Fnt: tFont;
    tM:tTextMetric;
    SavObj:hgdiObj;
    ptrPropInfo : PPropInfo;
begin
  ptrPropInfo := GetPropInfo(pCControl.ClassInfo, 'Font');
  if ptrPropInfo = NIL then exit;
  Fnt := TFont(GetOrdProp(pCControl, ptrPropInfo));
  if GetcaretPos(CP) then begin
    aDC := getDC(pCControl.Handle);
    if aDC <> 0 then begin
      SavObj := SelectObject(aDC,Fnt.handle);
      if SavObj <> 0 then begin
        if GetTextMetrics(aDC,tm) then begin
          R := Rect(CP.X,CP.Y,CP.X+2,CP.Y+tm.tmHeight);
          aBrush := GetStockObject(StockBrush);
          if aBrush <> 0 then FillRect(aDC,R,aBrush);
        end;
        SelectObject(aDC,SavObj);
      end;
      ReleaseDC(pCControl.handle,aDC);
      {deleteObject,..fnt NE, protoze font tu nebyl vytvoren }
    end;
  end;
end;


{ TExpressionBuildDlg }

procedure TExpressionBuildDlg.DoIdle(Sender: TObject; var Done: Boolean);
begin
  if Assigned(OldOnIdle) then OldOnIdle(Sender,Done);
  HelpBtn.Enabled := IdentifBox.ItemIndex >= 0;
  UseItBtn.Enabled := IdentifBox.ItemIndex >= 0;
  TestBtn.Enabled := (ResultMemo.Text <> '') and (TestExpr <> NIL);
end;

Procedure TExpressionBuildDlg.AddTomemo(Const S:String; amemo:tmemo);
begin
  with amemo do begin
    SelLength := 0;
    SelText  := S;
    amemo.SetFocus;
  end;
end;

Procedure TExpressionBuildDlg.BuildClassIdList(aList:tStrings);
var
  prec:pexprocrec;
  s:String[80];
begin
  prec := Listroot;
  while prec <> NIL  do begin
    if prec^.ClassIdentif <> NIL then begin
      s := ' '+StrPas(prec.ClassIdentif);
      if aList.IndexOf(s) < 0 then aList.Add(S);
    end;
    prec := prec^.next;
  end
end;

Procedure TExpressionBuildDlg.BuildIdentifList(aClassIdBox:tCustomListBox;IdentifList:tStrings);
var
  I: Integer;
  prec:pexprocrec;
  s,t:String[80];
begin
  I := aClassIdBox.ItemIndex;
  if i >= 0 then begin
    t := aClassIdBox.Items.Strings[i];
    Delete(t,1,1); { pocatecni mezera}
    prec := Listroot;
    identiflist.Clear;
    while prec <> NIL  do begin
      if prec^.ClassIdentif <> NIL then begin
        if StrPas(prec^.ClassIdentif) = t then begin
          if prec^.pIdentif <> NIL then begin
            S := StrPas(prec^.pIdentif);
            if (pRec.Attrib = 0) and
               (pRec.Param1 <> ext_Null) then { funkce } begin
              if pRec.param5 <> ext_Null then S := S + '( , , , , )' else
              if pRec.param4 <> ext_Null then S := S + '( , , , )' else
              if pRec.param3 <> ext_Null then S := S + '( , , )' else
              if pRec.param2 <> ext_Null then S := S + '( , )' else
              S := S + '( )';
            end;
            S := ' '+S+' ';
            if IdentifList.IndexOf(s) < 0 then IdentifList.AddObject(S,pointer(pRec));
          end
        end
      end;
      prec := prec^.next;
    end
  end
end;


procedure TExpressionBuildDlg.FormCreate(Sender: TObject);
begin
  PeriodBtn.caption := DecimalSeparator;
end;

Procedure TExpressionBuildDlg.DlgUpdate;
begin
  BuildIdentifList(ClassIdBox,IdentifBox.Items);
  SetItemhelp;
end;

procedure TExpressionBuildDlg.ClassIdBoxClick(Sender: TObject);
begin
  DlgUpdate;
end;

procedure TExpressionBuildDlg.UseItBtnClick(Sender: TObject);
var i:Integer;
begin
  I := IdentifBox.ItemIndex;
  if I >= 0 then begin
    AddTomemo(Trim(IdentifBox.Items.Strings[i])+' ',Resultmemo);
  end;
end;


procedure TExpressionBuildDlg.IdentifBoxDblClick(Sender: TObject);
begin
  UseItBtnClick(Self);
end;


procedure TExpressionBuildDlg.ResultmemoExit(Sender: TObject);
begin
  DrawPseudocaret(Resultmemo,GRAY_BRUSH);
end;

procedure TExpressionBuildDlg.ResultmemoEnter(Sender: TObject);
begin
  Resultmemo.Invalidate;
end;

procedure TExpressionBuildDlg.CaptionBtnClick(Sender: TObject);
begin
  With Sender As tButton do AddTomemo(caption,Resultmemo);
end;

procedure TExpressionBuildDlg.IdentifBoxClick(Sender: TObject);
begin
  SetItemhelp;
end;

procedure TExpressionBuildDlg.FormActivate(Sender: TObject);
begin { musi byt tady, nelze do OnCreate, protoze v OnCreate kontrolky jeste nejsou viditelne }
  Resultmemo.SetFocus;
end;

procedure TExpressionBuildDlg.TestBtnClick(Sender: TObject);
begin
  TestExpr.SetText(Resultmemo.Text,ListRoot);
  if not (TestExpr.ResultType in ExpResults) then
  raise Exception.Create('Invalid result type');
  { pokud nedoslo k vyjimce, dojde to az sem:}
  Showmessage('Expression is OK');
end;

procedure TExpressionBuildDlg.helpBtnClick(Sender: TObject);
begin
  SetItemhelp;
  if assigned(InvokehelpProc) then tOnInvokeHelp(InvokehelpProc)(helpFile,helpContext);
end;

procedure TExpressionBuildDlg.SetItemhelp;
Var I: Integer;
begin
  HelpContext := 0;
  I := IdentifBox.ItemIndex;
  if I >= 0 then begin
    With pexprocrec(IdentifBox.Items.Objects[I])^ do begin
      if HelpFilename <> NIL then begin
        Self.HelpFile := HelpFilename;
      end else Self.HelpFile := NIL;
      if I >= 0 then Self.helpContext := helpContext
      else self.helpContext := 0;
    end;
  end;
end;

end.
