{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

{
  This unit demonstrates the use of Exparse in implementing
  function charts
}

unit Main;
{$I ..\alldemo.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  ParseH,ExprObj, TeeProcs, TeEngine, Chart, Series, Spin;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Button3: TButton;
    Chart1: TChart;
    Series1: TFastLineSeries;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    XprocRec: texprocRec;
    XProcIdentif,
    XClassIdentif: string;
    Expr: tExpression;
    ListRoot: pexProcRec;
    CurrXValue: Double;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses BaseOp,MoreOp,ExprBldr;

{$R *.DFM}

procedure InvokeBuilderHelp(lpHFname: pChar; HContext: word);
var savhlpFile: string;
begin
  savhlpFile := application.helpfile;
  Try
    application.helpfile := lpHFname;
    Application.HelpContext(HContext);
  Finally
    application.helpfile := savhlpFile;
  End;
end;

Function XValue(prec: pexProcRec;Exprhandle: tExprHandle; Reserved1: Pointer):variant; stdcall;
begin
  Result := frmMain.CurrXValue;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RegisterBaseOpNEXT(ListRoot);
  RegisterMoreOpNEXT(ListRoot);
  XProcIdentif:='X'#0;
  XClassIdentif := 'Application variables'#0;
  XprocRec.PIdentif := @XProcIdentif[1];
  XprocRec.ClassIdentif  := @XClassIdentif[1];
  XprocRec.Attrib   := 0;
  XprocRec.ProcAddr := @XValue;
  XprocRec.aResult  := ext_Number;
  NextRegisterODR(ListRoot,@XProcRec);
  Expr := tExpression.Create;
  Button1Click(Sender);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  Expr.Free;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
const
  steps=1000;
var
  y,delta,Start,Stop: double;
  Err,
  i: integer;
begin
  Chart1.Title.Text.Clear;
  Expr.SetText(Edit1.Text,ListRoot);
  if Expr.ResultType <> ext_Number then raise exception.Create('real function is required');
  Start := SpinEdit1.Value;
  Stop  := SpinEdit2.Value;
  if Start >= Stop then raise exception.Create('invalid interval for x');
  Series1.Clear;
  delta := (Stop-Start)/steps;
  for i := 0 to steps do begin
    CurrXvalue := Start + i*delta;
    Expr.Execute(Err);
    if Err = 0 then begin
      y := Expr.AsNumber;
      Series1.AddXY(CurrXvalue,y,'',clteeColor);
    end else  ;
  end;
  Chart1.Title.Text.Add(Expr.GetText);
end;

procedure TfrmMain.Button3Click(Sender: TObject);
var s: string;
begin
  s := edit1.text;
  if _BuildExpr(s,Listroot,[ext_Number],@InvokeBuilderHelp) then
    edit1.text := s;
end;

end.
