{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

{
  This units contains Operation Definition Records for
  engineering and statistical functions
}

unit MoreOp;
{$I ..\alldemo.inc}

interface
USES Windows,Sysutils,Math,
     PARSEH,
     ExMath;


Procedure RegisterMoreOpNEXT(var ListRoot: pexProcRec);
{ Links all operation definition records via NEXT field.
  This chain is used by exparse DLL routines }
Procedure RegisterMoreOpUSER(var ListRoot: pexProcRec; VAR Total: longint);
{ Links all operation definition records via USERPTR field.
  This chain is used by demo applications }

Implementation

CONST

{$I OP_HCTX.INC}

  HlpFile : array [0..13] of Char = 'MOREOP.HLP';
                                                   {12345678901234567890123456789}
  ClassIdMathOper       :  array [0..21] of Char = 'Engineering functions';
  ClassIdStatisticOper  :  array [0..21] of Char=  'Statistical functions';

{***********************}
{ Engineering functions }
{***********************}

{constants}
IdPI       : array [0..2] of Char = 'PI';
IdE        : array [0..1] of Char = 'E';

{-- cosine funcs --}
{trig}
IdCos      : array [0..3] of Char = 'COS';
{inverse}
IdArcCos   : array [0..4] of Char = 'ACOS';
{hyperbolic}
IdCosh     : array [0..4] of Char = 'COSH';
{inverse hyperbolic}
IdArcCosh  : array [0..5] of Char = 'ACOSH';

{-- sine funcs --}
{trig}
IdSin      : array [0..3] of Char = 'SIN';
{inverse}
IdArcSin   : array [0..4] of Char = 'ASIN';
{hyperbolic}
IdSinh     : array [0..4] of Char = 'SINH';
{inverse hyperbolic}
IdArcSinh  : array [0..5] of Char = 'ASINH';

{-- tangent funcs --}
{trig}
IdTan      : array [0..3] of Char = 'TAN';
{inverse}
IdArcTan   : array [0..4] of Char = 'ATAN';
{hyperbolic}
IdTanh     : array [0..4] of Char = 'TANH';
{inverse hyperbolic}
IdArcTanh  : array [0..5] of Char = 'ATANH';

{-- logarithms --}
{base e}
IdLog      : array [0..2] of Char = 'LN';
{base 2}
IdLog2     : array [0..3] of Char = 'LN2';
{base 10}
IdLog10    : array [0..4] of Char = 'LN10';

{-- exponentials --}
{powers of e}
IdEXP      : array [0..3]  of Char ='EXP';
{powers of 2}
IdEXP2     : array [0..4]  of Char ='EXP2';
{powers of 10}
IdEXP10    : array [0..5]  of Char ='EXP10';

{float power}
IdPower    : array [0..5] of Char = 'POWER';
{integer power}
IdIPower   : array [0..6] of Char = 'IPOWER';

{***********************}
{ Statistical functions }
{***********************}

{logarithm of Gamma func}
IdLNGAMMA  : array [0..7]  of Char ='LNGAMMA';
{logarithm of Beta func}
IdLNBETA   : array [0..6]  of Char ='LNBETA';

{-- Normal distribution --}
{ density }
IdNDENS    : array [0..5]  of Char ='NDENS';
{ cumulative distribution function }
IdNDF      : array [0..3]  of Char ='NDF';
{ quantil function - inverse of cumulative distribution function }
IdNINV     : array [0..4]  of Char ='NINV';

{-- Chi-square --}
{ density }
IdCHIDENS  : array [0..7]  of Char ='CHIDENS';
{ cumulative distribution function }
IdCHIDF    : array [0..5]  of Char ='CHIDF';
{ quantil function - inverse of cumulative distribution function }
IdCHIINV   : array [0..6]  of Char ='CHIINV';

{-- Beta --}
{ density }
IdBETADENS : array [0..8]  of Char ='BETADENS';
{ cumulative distribution function }
IdBETADF   : array [0..6]  of Char ='BETADF';
{ quantil function - inverse of cumulative distribution function }
IdBETAINV  : array [0..7]  of Char ='BETAINV';

{-- F (Fisher-Snedecor) --}
{ density }
IdFDENS    : array [0..5]  of Char ='FDENS';
{ cumulative distribution function }
IdFDF      : array [0..3]  of Char ='FDF';
{ quantil function - inverse of cumulative distribution function }
IdFINV     : array [0..4]  of Char ='FINV';

{-- Student (T) --}
{ density }
IdTDENS    : array [0..5]  of Char ='TDENS';
{ cumulative distribution function }
IdTDF      : array [0..3]  of Char ='TDF';
{ quantil function - inverse of cumulative distribution function }
IdTINV     : array [0..4]  of Char ='TINV';

{ Binomial coef }
IdBINOM    : array [0..5]  of Char ='BINOM';
{ Mann-Whitney cumulative frequency distribution }
IdMWCFD    : array [0..5]  of Char ='MWCFD';
{ cumulative distr. func of two-sample Mann-Whitney statistics }
IdMWDF     : array [0..4]  of Char ='MWDF';
{ cumulative distr. func of two-sample Wilcoxon statistics }
IdWILCOXDF : array [0..8]  of Char ='WILCOXDF';

{Uniformly distributed random numbers }
  {Op1 =0   ... R[0,1] continuous }
  {Op1 =N>0 ... R[1..N] discrete }
IdRANDOM   : array [0..6]  of Char ='RANDOM';

{Normally distributed random numbers }
IdRandomG  : array [0..5]  of Char ='RANDG';


{************************************}
{ Eval funcs - Engineering functions }
{************************************}


function Func0(prec: pexprocRec; Exprhandle: tExprHandle;Reserved1: Pointer): Variant; stdcall;
begin
  if prec.pidentif = IdPI then Result := PI else
  if prec.pidentif = IdE then Result := exp(1)
end;

function FuncExp(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdExp       then Result := EXP(x) else
  if prec.pidentif = IdEXP10     then Result := EXP10(x) else
  if prec.pidentif = IdEXP2      then Result := EXP2(x)
end;

function FuncLog(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdLog       then Result := Ln(x) else
  if prec.pidentif = IdLog2      then Result := Log2(x) else
  if prec.pidentif = IdLog10     then Result := Log10(x)
end;

function FuncCos(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdCos       then Result := Cos(x) else
  if prec.pidentif = IdArcCos    then Result := ArcCos(x) else
  if prec.pidentif = IdCosh      then Result := Cosh(x) else
  if prec.pidentif = IdArcCosh   then Result := ArcCosh(x)
end;

function FuncSin(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdSin       then Result := Sin(x) else
  if prec.pidentif = IdArcSin    then Result := ArcSin(x) else
  if prec.pidentif = IdSinh      then Result := Sinh(x) else
  if prec.pidentif = IdArcSinh   then Result := ArcSinh(x)
end;

function FuncTan(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdTan       then Result := Tan(x) else
  if prec.pidentif = IdArcTan    then Result := ArcTan(x) else
  if prec.pidentif = IdTanh      then Result := Tanh(x) else
  if prec.pidentif = IdArcTanh   then Result := ArcTanh(x)
end;

function FuncLnGamma(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  Result := LnGamma(x)
end;


function FuncPower(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  if prec.pidentif = IdPower     then begin
    if y=0 then Result := 1 else Result := Power(x,y)
  end else
  if prec.pidentif = IdIPower   then begin
    if y=0 then Result := 1 else Result := IntPower(x,round(y))
  end
end;

function FuncRandG(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  Result := RandG(x,y);
end;

function FuncLnBeta(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  result := LnBeta(x,y)
end;


{************************************}
{ Eval funcs - Statistical functions }
{************************************}


    { ***** N(0,1)                                            ***** }

function FuncNormal(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  if prec.pidentif = IdNDens       then Result := NormalDensity(x) else
  if prec.pidentif = IdNDF         then Result := NormalDF(x) else
  if prec.pidentif = IdNINV        then Result := NormalKvantil(x)
end;

    { ***** Chi-square  ***** }

function FuncChiSquare(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  if prec.pidentif = IdChiDens       then Result := ChiSquareDensity(round(x),y) else
  if prec.pidentif = IdChiDF         then Result := ChiSquareDF(round(x),y) else
  if prec.pidentif = IdChiINV        then Result := ChiSquareKvantil(round(x),y)
end;


    { ***** Beta  ***** }

function FuncBeta(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2,op3: variant): Variant; stdcall;
var x,y,z: exNumber;
begin
  x := Op1; y := Op2; z := Op3;
  if prec.pidentif = IdBetaDens       then Result := BetaDensity(x,y,z) else
  if prec.pidentif = IdBetaDF         then Result := BetaDF(x,y,z) else
  if prec.pidentif = IdBetaINV        then Result := BetaKvantil(x,y,z)
end;


    { ***** F ***** }

function FuncFisher_Snedecor(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2,op3: variant): Variant; stdcall;
var x,y,z: exNumber;
begin
  x := Op1; y := Op2; z := Op3;
  if prec.pidentif = IdFDens       then Result := Fisher_SnedecorDensity(round(x),round(y),z) else
  if prec.pidentif = IdFDF         then Result := Fisher_SnedecorDF(round(x),round(y),z) else
  if prec.pidentif = IdFINV        then Result := Fisher_SnedecorKvantil(round(x),round(y),z)
end;


    { ***** Student ***** }

function FuncStudent(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  if prec.pidentif = IdTDens       then Result := StudentDensity(round(x),y) else
  if prec.pidentif = IdTDF         then Result := StudentDF(round(x),y) else
  if prec.pidentif = IdTINV        then Result := StudentKvantil(round(x),y)
end;

    { ***** Non-parametric tests **** }

    { binomial coef }
function FuncBinom(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2: variant): Variant; stdcall;
var x,y: exNumber;
begin
  x := Op1; y := Op2;
  Result := Binom(round(x),round(y));
end;

   { Mann-Whitney cumulative freq. distrib. func }
function FuncMannWhittney(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1,Op2,Op3: variant): Variant; stdcall;
var x,y,z: exNumber;
begin
  x := Op1; y := Op2; z := Op3;
  if prec.pidentif = IdMWCFD then Result := M_WCFD(round(x),round(y),round(z)) else
  if prec.pidentif = IdMWDF  then Result := Mann_WhitneyDF(round(x),round(y),round(z)) else
  if prec.pidentif = IdWilcoxDF  then Result := WilcoxonDF(round(x),round(y),round(z))
end;

{ ** Random numbers ** }

Function MyMyRandom(prec: pexprocRec;Exprhandle: tExprHandle;Reserved1: Pointer; Const op1: variant): Variant; stdcall;
var x: exNumber;
begin
  x := Op1;
  MyMyRandom := MyRandom(round(x));
end;



VAR

{******************************************************}
{ Operation Definition Records - Engineering functions }
{******************************************************}


RIDPI       : texProcRec=(
              Pidentif :@IDPI;
              attrib    :atlo_function;
              procAddr  :@Func0;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_PI;
              aResult  :ext_number);
RIDE        : texProcRec=(
              Pidentif :@IDE;
              attrib    :atlo_function;
              procAddr  :@Func0;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_E;
              aResult  :ext_number);
RIDCos      : texProcRec=(
              Pidentif :@IDCos;
              attrib    :atlo_function;
              procAddr  :@FuncCos;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Cos;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcCos   : texProcRec=(
              Pidentif :@IDArcCos;
              attrib    :atlo_function;
              procAddr  :@FuncCos;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ACos;
              aResult  :ext_number;
              Param1   :ext_number);
RIDCosh     : texProcRec=(
              Pidentif :@IDCosh;
              attrib    :atlo_function;
              procAddr  :@FuncCos;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Cosh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcCosh  : texProcRec=(
              Pidentif :@IDArcCosh;
              attrib    :atlo_function;
              procAddr  :@FuncCos;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ACosh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDSin      : texProcRec=(
              Pidentif :@IDSin;
              attrib    :atlo_function;
              procAddr  :@FuncSin;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Sin;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcSin   : texProcRec=(
              Pidentif :@IDArcSin;
              attrib    :atlo_function;
              procAddr  :@FuncSin;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ASin;
              aResult  :ext_number;
              Param1   :ext_number);
RIDSinh     : texProcRec=(
              Pidentif :@IDSinh;
              attrib    :atlo_function;
              procAddr  :@FuncSin;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Sinh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcSinh  : texProcRec=(
              Pidentif :@IDArcSinh;
              attrib    :atlo_function;
              procAddr  :@FuncSin;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ASinh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDTan      : texProcRec=(
              Pidentif :@IDTan;
              attrib    :atlo_function;
              procAddr  :@FuncTan;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Tan;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcTan   : texProcRec=(
              Pidentif :@IDArcTan;
              attrib    :atlo_function;
              procAddr  :@FuncTan;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ATan;
              aResult  :ext_number;
              Param1   :ext_number);
RIDTanh     : texProcRec=(
              Pidentif :@IDTanh;
              attrib    :atlo_function;
              procAddr  :@FuncTan;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Tanh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDArcTanh  : texProcRec=(
              Pidentif :@IDArcTanh;
              attrib    :atlo_function;
              procAddr  :@FuncTan;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ATanh;
              aResult  :ext_number;
              Param1   :ext_number);
RIDLog      : texProcRec=(
              Pidentif :@IDLog;
              attrib    :atlo_function;
              procAddr  :@FuncLog;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Log;
              aResult  :ext_number;
              Param1   :ext_number);
RIDLog2     : texProcRec=(
              Pidentif :@IDLog2;
              attrib    :atlo_function;
              procAddr  :@FuncLog;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Log2;
              aResult  :ext_number;
              Param1   :ext_number);
RIDLog10    : texProcRec=(
              Pidentif :@IDLog10;
              attrib    :atlo_function;
              procAddr  :@FuncLog;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Log10;
              aResult  :ext_number;
              Param1   :ext_number);
RIDEXP      : texProcRec=(
              Pidentif :@IDExp;
              attrib    :atlo_function;
              procAddr  :@FuncExp;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Exp;
              aResult  :ext_number;
              Param1   :ext_number);
RIDEXP10    : texProcRec=(
              Pidentif :@IDExp10;
              attrib    :atlo_function;
              procAddr  :@FuncExp;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Exp10;
              aResult  :ext_number;
              Param1   :ext_number);
RIDEXP2     : texProcRec=(
              Pidentif :@IDExp2;
              attrib    :atlo_function;
              procAddr  :@FuncExp;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Exp2;
              aResult  :ext_number;
              Param1   :ext_number);
RIDPower    : texProcRec=(
              Pidentif :@IDPower;
              attrib    :atlo_function;
              procAddr  :@FuncPower;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Power;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDIPower   : texProcRec=(
              Pidentif :@IDIPower;
              attrib    :atlo_function;
              procAddr  :@FuncPower;
              ClassIdentif : @ClassIdMathOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_IPower;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);

{******************************************************}
{ Operation Definition Records - Statistical functions }
{******************************************************}

RIDLNGAMMA  : texProcRec=(
              Pidentif :@IDLnGamma;
              attrib    :atlo_function;
              procAddr  :@FuncLnGamma;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_LnGamma;
              aResult  :ext_number;
              Param1   :ext_number);
RIDLNBETA   : texProcRec=(
              Pidentif :@IDLnBeta;
              attrib    :atlo_function;
              procAddr  :@FuncLnBeta;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_LnBeta;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDNDENS    : texProcRec=(
              Pidentif :@IDNdens;
              attrib    :atlo_function;
              procAddr  :@FuncNormal;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Ndens;
              aResult  :ext_number;
              Param1   :ext_number);
RIDNDF      : texProcRec=(
              Pidentif :@IDNDF;
              attrib    :atlo_function;
              procAddr  :@FuncNormal;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_NDF;
              aResult  :ext_number;
              Param1   :ext_number);
RIDNINV     : texProcRec=(
              Pidentif :@IDNInv;
              attrib    :atlo_function;
              procAddr  :@FuncNormal;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_NInv;
              aResult  :ext_number;
              Param1   :ext_number);
RIDCHIDENS  : texProcRec=(
              Pidentif :@IDChidens;
              attrib    :atlo_function;
              procAddr  :@FuncChiSquare;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Chidens;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDCHIDF    : texProcRec=(
              Pidentif :@IDChiDF;
              attrib    :atlo_function;
              procAddr  :@FuncChiSquare;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ChiDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDCHIINV   : texProcRec=(
              Pidentif :@IDChiInv;
              attrib    :atlo_function;
              procAddr  :@FuncChiSquare;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_ChiInv;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDBETADENS : texProcRec=(
              Pidentif :@IDBetadens;
              attrib    :atlo_function;
              procAddr  :@FuncBeta;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Betadens;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDBETADF   : texProcRec=(
              Pidentif :@IDBetaDF;
              attrib    :atlo_function;
              procAddr  :@FuncBeta;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_BetaDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDBETAINV  : texProcRec=(
              Pidentif :@IDBetaInv;
              attrib    :atlo_function;
              procAddr  :@FuncBeta;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_BetaInv;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDFDENS    : texProcRec=(
              Pidentif :@IDFDens;
              attrib    :atlo_function;
              procAddr  :@FuncFisher_Snedecor;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_FDens;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDFDF      : texProcRec=(
              Pidentif :@IDFDF;
              attrib    :atlo_function;
              procAddr  :@FuncFisher_Snedecor;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_FDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDFINV     : texProcRec=(
              Pidentif :@IDFInv;
              attrib    :atlo_function;
              procAddr  :@FuncFisher_Snedecor;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_FInv;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDTDENS    : texProcRec=(
              Pidentif :@IDTDens;
              attrib    :atlo_function;
              procAddr  :@FuncStudent;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_TDens;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDTDF      : texProcRec=(
              Pidentif :@IDTDF;
              attrib    :atlo_function;
              procAddr  :@FuncStudent;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_TDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDTINV     : texProcRec=(
              Pidentif :@IDTINV;
              attrib    :atlo_function;
              procAddr  :@FuncStudent;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_TINV;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDBINOM    : texProcRec=(
              Pidentif :@IDBinom;
              attrib    :atlo_function;
              procAddr  :@FuncBinom;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_Binom;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);
RIDMWCFD    : texProcRec=(
              Pidentif :@IDMWCFD;
              attrib    :atlo_function;
              procAddr  :@FuncMannWhittney;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_MWCFD;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDMWDF     : texProcRec=(
              Pidentif :@IDMWDF;
              attrib    :atlo_function;
              procAddr  :@FuncMannWhittney;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_MWDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDWILCOXDF : texProcRec=(
              Pidentif :@IDWILCOXDF;
              attrib    :atlo_function;
              procAddr  :@FuncMannWhittney;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_WILCOXDF;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number;
              Param3   :ext_number);
RIDRANDOM   : texProcRec=(
              Pidentif :@IDRANDOM;
              attrib    :atlo_function;
              procAddr  :@MyMyRandom;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_RANDOM;
              aResult  :ext_number;
              Param1   :ext_number);

RIDRANDOMG  : texProcRec=(
              Pidentif :@IDRANDOMG;
              attrib    :atlo_function;
              procAddr  :@funcrandg;
              ClassIdentif : @ClassIdStatisticOper;
              HelpFilename : @HlpFile;
              HelpContext  : OPER_ID_RANDOMG;
              aResult  :ext_number;
              Param1   :ext_number;
              Param2   :ext_number);

Procedure RegisterMoreOpNEXT(var ListRoot: pexProcRec);
begin
NEXTRegisterODR(ListRoot,@RidPI       );
NEXTRegisterODR(ListRoot,@RidE        );
NEXTRegisterODR(ListRoot,@RidCos      );
NEXTRegisterODR(ListRoot,@RidArcCos   );
NEXTRegisterODR(ListRoot,@RidCosh     );
NEXTRegisterODR(ListRoot,@RidArcCosh  );
NEXTRegisterODR(ListRoot,@RidSin      );
NEXTRegisterODR(ListRoot,@RidArcSin   );
NEXTRegisterODR(ListRoot,@RidSinh     );
NEXTRegisterODR(ListRoot,@RidArcSinh  );
NEXTRegisterODR(ListRoot,@RidTan      );
NEXTRegisterODR(ListRoot,@RidArcTan   );
NEXTRegisterODR(ListRoot,@RidTanh     );
NEXTRegisterODR(ListRoot,@RidArcTanh  );
NEXTRegisterODR(ListRoot,@RidLog      );
NEXTRegisterODR(ListRoot,@RidLog2     );
NEXTRegisterODR(ListRoot,@RidLog10    );
NEXTRegisterODR(ListRoot,@RidEXP      );
NEXTRegisterODR(ListRoot,@RidEXP10    );
NEXTRegisterODR(ListRoot,@RidEXP2     );
NEXTRegisterODR(ListRoot,@RidPower    );
NEXTRegisterODR(ListRoot,@RidIPower   );
NEXTRegisterODR(ListRoot,@RidLNGAMMA  );
NEXTRegisterODR(ListRoot,@RidLNBETA   );
NEXTRegisterODR(ListRoot,@RidNDENS    );
NEXTRegisterODR(ListRoot,@RidNDF      );
NEXTRegisterODR(ListRoot,@RidNINV     );
NEXTRegisterODR(ListRoot,@RidCHIDENS  );
NEXTRegisterODR(ListRoot,@RidCHIDF    );
NEXTRegisterODR(ListRoot,@RidCHIINV   );
NEXTRegisterODR(ListRoot,@RidBETADENS );
NEXTRegisterODR(ListRoot,@RidBETADF   );
NEXTRegisterODR(ListRoot,@RidBETAINV  );
NEXTRegisterODR(ListRoot,@RidFDENS    );
NEXTRegisterODR(ListRoot,@RidFDF      );
NEXTRegisterODR(ListRoot,@RidFINV     );
NEXTRegisterODR(ListRoot,@RidTDENS    );
NEXTRegisterODR(ListRoot,@RidTDF      );
NEXTRegisterODR(ListRoot,@RidTINV     );
NEXTRegisterODR(ListRoot,@RidBINOM    );
NEXTRegisterODR(ListRoot,@RidMWCFD    );
NEXTRegisterODR(ListRoot,@RidMWDF     );
NEXTRegisterODR(ListRoot,@RidWILCOXDF );
NEXTRegisterODR(ListRoot,@RidRANDOM   );
NEXTRegisterODR(ListRoot,@RidRANDOMG  );
end;

Procedure RegisterMoreOpUSER(var ListRoot: pexProcRec; VAR Total: longint);
begin
UserRegisterODR(ListRoot,@RidPI       ,total);
UserRegisterODR(ListRoot,@RidE        ,total);
UserRegisterODR(ListRoot,@RidCos      ,total);
UserRegisterODR(ListRoot,@RidArcCos   ,total);
UserRegisterODR(ListRoot,@RidCosh     ,total);
UserRegisterODR(ListRoot,@RidArcCosh  ,total);
UserRegisterODR(ListRoot,@RidSin      ,total);
UserRegisterODR(ListRoot,@RidArcSin   ,total);
UserRegisterODR(ListRoot,@RidSinh     ,total);
UserRegisterODR(ListRoot,@RidArcSinh  ,total);
UserRegisterODR(ListRoot,@RidTan      ,total);
UserRegisterODR(ListRoot,@RidArcTan   ,total);
UserRegisterODR(ListRoot,@RidTanh     ,total);
UserRegisterODR(ListRoot,@RidArcTanh  ,total);
UserRegisterODR(ListRoot,@RidLog      ,total);
UserRegisterODR(ListRoot,@RidLog2     ,total);
UserRegisterODR(ListRoot,@RidLog10    ,total);
UserRegisterODR(ListRoot,@RidEXP      ,total);
UserRegisterODR(ListRoot,@RidEXP10    ,total);
UserRegisterODR(ListRoot,@RidEXP2     ,total);
UserRegisterODR(ListRoot,@RidPower    ,total);
UserRegisterODR(ListRoot,@RidIPower   ,total);
UserRegisterODR(ListRoot,@RidLNGAMMA  ,total);
UserRegisterODR(ListRoot,@RidLNBETA   ,total);
UserRegisterODR(ListRoot,@RidNDENS    ,total);
UserRegisterODR(ListRoot,@RidNDF      ,total);
UserRegisterODR(ListRoot,@RidNINV     ,total);
UserRegisterODR(ListRoot,@RidCHIDENS  ,total);
UserRegisterODR(ListRoot,@RidCHIDF    ,total);
UserRegisterODR(ListRoot,@RidCHIINV   ,total);
UserRegisterODR(ListRoot,@RidBETADENS ,total);
UserRegisterODR(ListRoot,@RidBETADF   ,total);
UserRegisterODR(ListRoot,@RidBETAINV  ,total);
UserRegisterODR(ListRoot,@RidFDENS    ,total);
UserRegisterODR(ListRoot,@RidFDF      ,total);
UserRegisterODR(ListRoot,@RidFINV     ,total);
UserRegisterODR(ListRoot,@RidTDENS    ,total);
UserRegisterODR(ListRoot,@RidTDF      ,total);
UserRegisterODR(ListRoot,@RidTINV     ,total);
UserRegisterODR(ListRoot,@RidBINOM    ,total);
UserRegisterODR(ListRoot,@RidMWCFD    ,total);
UserRegisterODR(ListRoot,@RidMWDF     ,total);
UserRegisterODR(ListRoot,@RidWILCOXDF ,total);
UserRegisterODR(ListRoot,@RidRANDOM   ,total);
UserRegisterODR(ListRoot,@RidRANDOMG  ,total);
end;

Initialization
  if IsLibrary then Randomize;

end.



