{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}


unit Flddef;
{$I ..\alldemo.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, DB, DBTables,
  PARSEH, EXPROBJ, DSETEXPR,
  ExprBldr;


type
  TFormFldDef = class(TForm)
    EditCaption: TEdit;
    EditExpression: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Button3: TButton;
    Label3: TLabel;
    EditName: TEdit;
    EditSize: TEdit;
    Label4: TLabel;
    EditDispFormat: TEdit;
    Label5: TLabel;
    procedure Button3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    OldFldName: string;
    Expr: tExpression;
    ODRRoot: pexProcRec;
    Dataset: tDataset;
  public
    { Public declarations }
  end;

Function EditCalcFld(aDataset: tdataset;
                     aODRRoot: pexProcRec;
                     Var aName,aCaption,aDispFmt,aExpression: string;
                     var aSize: byte): Boolean;

implementation


{$R *.DFM}


Function EditCalcFld(aDataset: tdataset;
                     aODRRoot: pexProcRec;
                     Var aName,aCaption,aDispFmt,aExpression: string;
                     var aSize: byte): Boolean;
begin
  Result := false;
  with TFormFldDef.Create(NIL) do TRY
    Dataset := aDataset;
    Expr := tExpression.Create;
    ODRRoot := aODRRoot;
    Editname.Text := aName;
    OldFldName := aName;
    EditCaption.Text := aCaption;
    EditSize.Text := IntToStr(aSize);
    EditDispFormat.Text := aDispFmt;
    EditExpression.Text := aExpression;
    if aname = '' then
      caption := 'Add calculated field'
    else
      caption := 'Edit calculated field';
    if ShowModal = mrOK then begin
      Result := True;
      aName := Editname.Text;
      aCaption := EditCaption.Text;
      aExpression := EditExpression.Text;
      aSize := StrToInt(EditSize.Text);
      aDispFmt := EditDispFormat.Text;
    end;
  Finally
    Expr.Free;
    Free;
  End;
end;

procedure TFormFldDef.Button3Click(Sender: TObject);
var s: string;
begin
  s := editExpression.text;
  if _BuildExpr(s,ODRRoot,[ext_Number..ext_Bool],@InvokeBuilderHelp) then
    editExpression.text := s;
end;

procedure TFormFldDef.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var b: integer;
begin
  if ModalResult = mrOK then begin
    Try
      if Editname.Text = '' then
        raise Exception.Create('Invalid field name');
      if (OldFldname='') or (Editname.Text <>OldFldname) then
        if Dataset.FindField(Editname.Text) <> NIL then
          raise Exception.Create('Duplicate field name');
      if EditSize.Text='' then EditSize.Text := '0';
      b := StrToInt(EditSize.Text);
      if (b > 255) or (b < 0) then
          raise Exception.Create('Invalid field size');
      Expr.SetText(EditExpression.Text,ODRRoot);
      if  NOT (Expr.Resulttype in [ext_Number..ext_Bool]) then
       raise Exception.Create('Invalid expression type');
    Except
      On E: Exception do begin
        ShowMessage(E.message);
        canclose := false;
      end;
    End;
  end;
end;

end.
