{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit Fltrdef;
{$I ..\alldemo.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, INIFiles,
  PARSEH, EXPROBJ, DSETEXPR,
  ExprBldr;

type
  TFormFilterDef = class(TForm)
    FilterCombo: TComboBox;
    ButtonBuilder: TButton;
    ButtonClear: TButton;
    ButtonApply: TButton;
    ButtonCancel: TButton;
    procedure ButtonBuilderClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    TestExpr: tExpression;
    ODRRoot: pexprocRec;
  public
    { Public declarations }
  end;

Function GetFilterText(var FltrText: String; aODRRoot: pexprocRec; aTestExpr: tExpression):Boolean;

implementation


{$R *.DFM}

Function GetFilterText(var FltrText: String; aODRRoot: pexprocRec; aTestExpr: tExpression):Boolean;
var i: integer;
    ININame,s: string;
begin
  With TFormFilterDef.Create(NIL) do TRY
    IniName := ChangeFileExt(Paramstr(0),'.INI');
    if FileExists(IniName) then
    With tIniFile.Create(IniName) do Try
      i := 0;
      Repeat
        s := ReadString('Filters',format('H%d',[i]),'');
        inc(i);
        if s <> '' then FilterCombo.Items.Add(s) else break
      Until i > 20;
      FilterCombo.Text := FltrText;
    Finally
      Free;
    End;
    TestExpr := aTestExpr;
    ODRRoot := aODRRoot;
    Result := ShowModal = mrOK;
    if Result then begin
      FltrText := FilterCombo.Text;
      With tIniFile.Create(ChangeFileExt(Paramstr(0),'.INI')) do Try
        EraseSection('Filters');
        for i := 0 to FilterCombo.Items.Count-1 do
          WriteString('Filters',format('H%d',[i]),FilterCombo.Items[i]);
      Finally
        Free;
      End;
    End;
  Finally
    Free;
  End;
end;

procedure TFormFilterDef.ButtonBuilderClick(Sender: TObject);
var s: string;
begin
  s := FilterCombo.text;
  if _BuildExpr(s,ODRRoot,[ext_Bool],@InvokeBuilderHelp) then
    FilterCombo.text := s;
end;

procedure TFormFilterDef.ButtonClearClick(Sender: TObject);
begin
  if FilterCombo.Text <> '' then
  if FilterCombo.Items.IndexOf(FilterCombo.Text) < 0 then
    FilterCombo.Items.Insert(0,FilterCombo.Text);
  FilterCombo.Text := '';
end;

procedure TFormFilterDef.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if ModalResult=mrOK then begin
    if FilterCombo.text <> '' then begin
      if TestExpr <> NIL then begin
        Try
          TestExpr.SetText(FilterCombo.text,ODRRoot);
          if TestExpr.Resulttype <> ext_Bool then
            raise Exception.Create('Boolean expression expected');
        Except
          On E: Exception do begin
            Showmessage(E.message);
            CanClose := False;
          end;
        End;
      end;
      if FilterCombo.Items.IndexOf(FilterCombo.Text) < 0 then
        FilterCombo.Items.Insert(0,FilterCombo.Text);
    end;
  end;
end;

end.
