{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit OlesrvH;
{$I ..\alldemo.inc}

interface
Uses Windows,Sysutils,Classes,Forms,Dialogs,
{$IFDEF VER90}
  Ole2, OleCtl,
{$ELSE}
  ActiveX,
{$ENDIF}
  PARSEH, EXPROBJ, DSETEXPR;


{$IFDEF VER90}
Const
 {IID's for Operation definition record server Interfaces }
  IID_IEnumODR: TGUID = (
    D1:$B4971A40;D2:$009E;D3:$11D2;D4:($90,$03,$00,$00,$C0,$06,$59,$D4));
       {B4971A40-009E-11D2-9003-0000C00659D4}
  IID_IODRSObject: TGUID = (
    D1:$B4971A41;D2:$009E;D3:$11D2;D4:($90,$03,$00,$00,$C0,$06,$59,$D4));
       {B4971A41-009E-11D2-9003-0000C00659D4}
Type
  IEnumODR = class(IUnknown) // Standard enumarator that enumerates Operation Definition Records
  public
    function Next(celt: Longint; var elt; pceltFetched: PLongint): HResult; virtual; stdcall; abstract;
    function Skip(celt: Longint): HResult; virtual; stdcall; abstract;
    function Reset: HResult; virtual; stdcall; abstract;
    function Clone(var enum: IEnumODR): HResult;  virtual; stdcall; abstract;
  end;
  IODRSObject = class(IUnknown) // Interface provided by the OLE server
  public
    function EnumODR(var EnumODR: IEnumODR): HResult; virtual; stdcall; abstract;
  end;
{$ELSE}
Type
  IEnumODR = interface;
  IODRSObject = interface;

  IEnumODR = interface(IUnknown)
    ['{B4971A40-009E-11D2-9003-0000C00659D4}']
    function Next(celt: Integer; out elt; pceltFetched: Pointer): HResult; stdcall;
    function Skip(celt: Integer): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enum: IEnumODR): HResult; stdcall;
  end;

  IODRSObject = interface(IUnknown)
    ['{B4971A41-009E-11D2-9003-0000C00659D4}']
    function EnumODR(out EnumODR: IEnumODR): HResult; stdcall;
  end;
{$ENDIF}

VAR
  CurrentServerClsID: TGUID;
  RuntimeLickey : String;
{ License key string.
  If the machine is fully licensed - usually this means that a .LIC file is present
  in the folder with server DLL, the Runtime license key is not needed because the server
  recognizes the machine as fully licensed. On a fully licensed machine, all clients do have
  access to the server component.
  Before deploying the DLL server and an application to machines that are not fully licensed,
  developper should obtain the Runtime License Key from the server - see the GetRuntimeLicKey
  function below - and store the value into his app somehow so the application can use it
  while calling Iclassfactory2.CreateInstanceLic in case ordinary coCreateInstance fails
  (and it will allways fail except on machines that are fully licensed). Only Server DLL (without the
  LIC file) should be deployed so only clients that do provide runtime license key do have acces to
  the server component. }


{Returns Run-time license key for given OLE server}
function GetRuntimeLicKey(CLSID: TGUID): String;

implementation

VAR
  ODRSObject: IODRSObject;
  OleInitialized,
  ServerRegistered : Boolean;

{ Following routine links Operation Definition Records handed out by IODRSObject interface
  to the list of Operation Definition Records Exparse.DLL iterates  when parsing
  an expression. }
Function RegisterODRServer(VAR ListRoot: pexProcRec;
                           ODRSObject: IODRSObject): HResult;
Var
  aEnumODR : IEnumODR;
  p: pexProcRec;
  celtFetched: Longint;
  hr : hResult;
begin
  Result := ODRSObject.EnumODR(aEnumODR);
  if Succeeded(Result) then begin
    hr := aEnumODR.Next(1,p,@celtFetched);
    While hr = S_OK do begin
      NextRegisterODR(ListRoot,p);
      hr := aEnumODR.Next(1,p,@celtFetched);
    end;
{$IFDEF VER90}
    aEnumODR.Release;
{$ENDIF}
  end;
end;

{ Following routine will get IODRSObject interface from Ole server specified
  and calls RegisterODRServer routine - see above }
Function RegisterODRServerOperations(Clsid: tClsid;              // GUID of server required
                                     VAR ListRoot: pexProcRec;   // current root of ODRs linked list
                                     VAR ODRSObject: IODRSObject // interface provided by server
                                     ): HResult;
VAR
  clsf: IClassfactory2;
{$IFDEF VER90}
  p: pOleStr;
{$ELSE}
  p: WideString;
{$ENDIF}
begin
{ First we try to obtain required interface in ordinary way. Request will succed
  if the component is either not protected by Iclassfactory2 licensing scheme,
  or it is protected, but machine is globally licensed. }
  Result := CoCreateInstance(CLSID,nil,CLSCTX_INPROC_SERVER,
                      {$IFDEF VER90}
                             IID_IODRSObject,
                      {$ELSE}
                             IODRSObject,
                      {$ENDIF}
                             ODRSObject);
{ If the component is protected by Iclassfactory2 licensing scheme and
  the machine is not globally licensed, server returns error code
  telling 'hahaha, anyone could be so smart, provide your license, please!'.... }
  if Result=CLASS_E_NOTLICENSED then begin
    {... in which case we must obtain interface directly from IclassFactory2.
     Se let's ask for IclassFactory2. }
    result := CoGetClassObject(CLSID,CLSCTX_INPROC_SERVER,nil,
                        {$IFDEF VER90}
                               IID_ICLASSFACTORY2,
                        {$ELSE}
                               ICLASSFACTORY2,
                        {$ENDIF}
                               clsf);
    if succeeded(result) then Try
    { We now have IclassFactory2. To obtain required interface from server
      protected by IclassFactory2 licensing scheme we must call
      IclassFactory2.CreateInstanceLic method }
{$IFDEF VER90}
      p :=  StringToOleStr(RuntimeLickey);
{$ELSE}
      p :=  RuntimeLickey;
{$ENDIF}
      Try
        Result := clsf.CreateInstanceLic(nil,nil,
{$IFDEF VER90}
                  IID_IODRSObject, //<- this tells what interface we want
{$ELSE}
                  IODRSObject,
{$ENDIF}
                  p,            //<- this is the license key
                  ODRSObject);  //<- this will return required interface
      Finally
{$IFDEF VER90}
        SysFreeString(p);
{$ENDIF}
      End;
    finally
{$IFDEF VER90}
      clsf.Release;
{$ENDIF}
    end else Showmessage('Strange, server does not support IClassfactory2');
  end;
  if succeeded(Result) then Result := RegisterODRServer(ListRoot,ODRSObject);
end;

{ Normally, the Ole server registration (creation of required REGISTRY entries) is performed during
  software installation. Unregistration is then performed during software uninstall.
  As there's no installation programme for this simple demo app, I am (un)registering
  the inproc server at runtime. This, of course, requires me to know where the DLL is located.
  Once the inproc server has been registered, the only thing I must know is the CLSID of the
  server object and no information about DLL physical location is required.
  Following routines do create (RegisterInprocServer) and remove (UnRegisterInprocServer)
  necessary registry entries.
  You can also call "Regsvr32" with proper command line to achieve the same thing.}

type tregproc = procedure; stdcall;
Const ServerDLLPath = 'ODRSBASE.DLL';
procedure RegisterInprocServer;
var h: thandle;
    regaddr: pointer;
begin
  if not ServerRegistered then begin
    h := LoadLibrary(ServerDLLPath);
    if h <> 0 then begin
      regaddr := GetprocAddress(h,'DllRegisterServer');
      if regaddr <> NIL then begin
        tregproc(regaddr);
        ServerRegistered := true;
      end;
      FreeLibrary(h);
    end;
  end;
  if not ServerRegistered then
    showmessage('Unable to register server');
end;
procedure UnRegisterInprocServer;
var h: thandle;
    regaddr: pointer;
begin
  if ServerRegistered then begin
    h := LoadLibrary(ServerDLLPath);
    if h <> 0 then begin
      regaddr := GetprocAddress(h,'DllUnregisterServer');
      if regaddr <> NIL then begin
        tregproc(regaddr);
        ServerRegistered := false;
      end;
      FreeLibrary(h);
    end;
  end;
  if ServerRegistered then
    showmessage('Unable to unregister server');
end;

{ The following routine shows how to obtain license key from inproc servers exposed
  through IClassfactory2. Request will fail if the machine is not globally licensed }
function GetRuntimeLicKey(CLSID: TGUID): String;
var hr : hResult;
    clsf: IClassfactory2;
    licInfo: TLicInfo;
{$IFDEF VER90}
    p: pOleStr;
{$ELSE}
    p: WideString;
{$ENDIF}
begin
  result := '';
  hr := CoGetClassObject(CLSID,CLSCTX_INPROC_SERVER,nil,
                  {$IFDEF VER90}
                         IID_ICLASSFACTORY2,
                  {$ELSE}
                         ICLASSFACTORY2,
                  {$ENDIF}
                         clsf);
  if succeeded(hr) then Try
    if succeeded(clsf.GetLicInfo(LicInfo)) then begin
      if LicInfo.fLicVerified then begin
        if succeeded(clsf.RequestLicKey(0,p)) then begin
{$IFDEF VER90}
          Result := OleStrToString(p);
          SysFreeString(p);
{$ELSE}
          Result := p;
{$ENDIF}
        end else raise Exception.Create('To my horror, server refuses to give me Runtime license key information');
      end else raise Exception.Create('Runtime key not available - machine is not fully licensed');
    end else raise Exception.Create('cannot get LicInfo structure');
  Finally
{$IFDEF VER90}
    clsf.Release;
{$ENDIF}
  end else
    raise Exception.Create('Server does not support IClassfactory2');
end;


{ Constants that are specific for the server we shall use in this demo app: }
Const
{ CLSID of server implementing basic operations. This server is implemented
  in ODRSbase project }
  CLSID_ODRSBase: TGUID = (
     D1:$DE74E000;D2:$013D;D3:$11D2;D4:($90,$03,$00,$00,$C0,$06,$59,$D4));
        {DE74E000-013D-11D2-9003-0000C00659D4}

  ODRSBaseRuntimeLickey = 'ODR Server Object with basic operations. Copyright  RK Solution 1996..1998.';

Initialization
{Set constants for ODRSBase server}
  CurrentServerClsID := CLSID_ODRSBase;
  RunTimeLicKey := ODRSBaseRuntimeLickey;
{Register operations provided by ODRSBase server}
  OleInitialized := Succeeded(OleInitialize(NIL));
  RegisterInprocServer;
  if not ServerRegistered then halt;
  case RegisterODRServerOperations(CurrentServerClsID, BaseOpRoot, ODRSObject) of
  S_OK: ;
  CLASS_E_NOTLICENSED: begin
        ShowMessage('You have no license to use this fine server');
        halt;
      end;
  else begin
      ShowMessage('Unable to register server''s procedures');
      halt;
    end
  end;

Finalization
{$IFDEF VER90}
  if ODRSObject <> NIL then ODRSObject.Release;
{$ENDIF}
  UnRegisterInprocServer;
  if OleInitialized then OleUNInitialize;


end.

