{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit ODRSClsF;
{$I ..\alldemo.inc}

interface
Uses Windows,Ole2,OleCtl,ODRSH;

Function DllGetClassObject(const clsid: TCLSID; const iid: TIID;var pv): HResult; stdcall;
Function DllCanUnloadNow:HResult; StdCall;
function DllRegisterServer: HResult; stdcall;
function DllUnregisterServer: HResult; stdcall;

Implementation
Uses OleSupp,ODRSVars,SrvObj;

Type
  ODRSClassFactory = Class(IClassFactory2)
    protected
        m_cRef: Longint;
    public
        //IUnknown members
        function QueryInterface(const iid: TIID; var obj): HResult;override; stdcall;
        function AddRef: Longint;override; stdcall;
        function Release: Longint;override; stdcall;
        //IClassFactory members
        function CreateInstance(unkOuter: IUnknown; const iid: TIID;
          var obj): HResult; override; stdcall;
        function LockServer(fLock: BOOL): HResult; override; stdcall;
        //IClassFactory2 members
        function GetLicInfo(var licInfo: TLicInfo): HResult; override; stdcall;
        function RequestLicKey(dwResrved: Longint; var bstrKey: TBStr): HResult; override; stdcall;
        function CreateInstanceLic(unkOuter: IUnknown; unkReserved: IUnknown;
          const iid: TIID; bstrKey: TBStr; var vObject): HResult; override; stdcall;
{implentation members:}
        function CreateInstanceInner(unkOuter: IUnknown; const iid: TIID;
          var obj): HResult;
    end;

//Count number of objects and number of locks.
VAR
  g_cLock: Longint=0;

Function DllGetClassObject(const clsid: TCLSID; const iid: TIID;var pv): HResult;
begin
 //Check that we can provide the interface
  if not (IsEqualIID(IID_IUnknown,iid) OR
          IsEqualIID(IID_IClassFactory,iid) OR
          IsEqualIID(IID_IClassFactory2,iid)
         ) then begin
    Result := E_NOINTERFACE; exit;
  end;
  IUnknown(pv) := NIL;
  //Check CLSIDs we support.
  if IsEqualCLSID(ExServer_CLSID,clsid) then IUnknown(pv) := ODRSClassFactory.Create;
  if IUnknown(pv) = NIL then Result := CLASS_E_CLASSNOTAVAILABLE else begin
    IUnknown(pv).AddRef;
    Result := S_OK;
  end;
end;

Function DllCanUnloadNow:HResult;
begin
  //Our answer is whether there are any object or locks
  if (0=ObjCount) AND (0=g_cLock) then Result := S_OK
  else Result := S_FALSE
end;

function ODRSClassFactory.QueryInterface(const iid: TIID; var obj): HResult;
begin
  IUnknown(obj) := NIL;
 //Any interface on this object is the object pointer.
  if IsEqualIID(IID_IUnknown,iid) OR
   IsEqualIID(IID_IClassFactory,iid) OR
   IsEqualIID(IID_IClassFactory2,iid) then IUnknown(obj) := Self;
  if IUnknown(obj) <> NIL then begin
    IUnknown(obj).AddRef;
    Result := S_OK;
  end else Result := E_NOINTERFACE;
end;

function ODRSClassFactory.AddRef: Longint;
begin
  Inc(m_cRef);
  Result := m_cRef;
end;

function ODRSClassFactory.Release: Longint;
begin
  Dec(m_cRef);
  Result := m_cRef;
  if 0 = m_cRef then begin
    Free;
  end;
end;

Function ODRSClassFactory.CreateInstance(unkOuter: IUnknown; const iid: TIID;
          var obj): HResult;
begin
  if not machinelicensed then Result := CLASS_E_NOTLICENSED
  else Result := CreateInstanceInner(unkOuter,iid,obj)
end;

function ODRSClassFactory.LockServer(fLock: BOOL): HResult;
begin
  if fLock then Inc(g_cLock)
  else Dec(g_cLock);
  Result := S_OK;
end;

function ODRSClassFactory.GetLicInfo(var licInfo: TLicInfo): HResult;
begin
  with licInfo do begin
    cbLicInfo := SizeOf(TLicInfo);
    fRuntimeKeyAvail := machinelicensed;
    fLicVerified  := machinelicensed;
  end;
  Result := S_OK;
end;

function ODRSClassFactory.RequestLicKey(dwResrved: Longint; var bstrKey: TBStr): HResult;
begin
  if not machinelicensed then Result := CLASS_E_NOTLICENSED
  else begin
    bstrKey := StringToOleStr(ExServer_LICKEY);
    Result := S_OK;
  end
end;

function ODRSClassFactory.CreateInstanceLic(unkOuter: IUnknown; unkReserved: IUnknown;
          const iid: TIID; bstrKey: TBStr; var vObject): HResult;
var Lic: string;
begin
  if bstrkey = NIL then Result := CLASS_E_NOTLICENSED
  else begin
    Lic := OleStrToString(bstrKey);
    if Lic=ExServer_LICKEY then Result := CreateInstanceInner(unkOuter,iid,vobject)
    else Result := CLASS_E_NOTLICENSED
  end;
end;

Function ODRSClassFactory.CreateInstanceInner(unkOuter: IUnknown; const iid: TIID;
          var obj): HResult;
VAR
  pObj: IODRSObject;
begin
  IUnknown(obj) := NIL;
  if NIL<>UnkOuter then begin
    Result := CLASS_E_NOAGGREGATION; exit;
  end;
 //Create the object
  TRY
    pObj:=IBaseODRSObject.Create;
    Result := pObj.QueryInterface(iid, Obj);
    //Kill the object if initial creation or Init failed.
    if FAILED(Result) then pObj.Free;
  EXCEPT
    Result := E_OUTOFMEMORY;
  END
end;

{ Reg/UnReg }


procedure UpdateRegistry(Register: Boolean);
var
  ClassID, FileName: string;
  Buffer: array[0..261] of Char;
begin
  ClassID := ClassIDToString(ExServer_CLSID);
  SetString(FileName, Buffer, GetModuleFileName(HInstance, Buffer,SizeOf(Buffer)));
  if Register then begin
    CreateRegKey('CLSID\' + ClassID, ExServer_Description);
    CreateRegKey('CLSID\' + ClassID + '\'+GetServerKey(True), FileName);
    CreateRegKey('CLSID\' + ClassID + '\NotInsertable', '');
  end else begin
    DeleteRegKey('CLSID\' + ClassID + '\NotInsertable');
    DeleteRegKey('CLSID\' + ClassID + '\'+GetServerKey(True));
    DeleteRegKey('CLSID\' + ClassID);
  end;
end;


function DllRegisterServer: HResult;
begin
  UpdateRegistry(True);
  Result := S_OK;
end;

function DllUnregisterServer: HResult;
begin
  UpdateRegistry(False);
  Result := S_OK;
end;


end.
