{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit SrvObj;
{$I ..\alldemo.inc}

interface
Uses Windows,Ole2,Sysutils,
     PARSEH,
     ODRSH,
     OleSupp,
     ODRSVars;

Type

  IBaseODRSObject = class(IODRSObject)
  private
    m_cRef: Longint;
  public
    Constructor Create;
    Destructor Destroy; override;
   //IUnknown members
    function QueryInterface(const iid: TIID; var obj): HResult; override; stdcall;
    function AddRef: Longint; override; stdcall;
    function Release: Longint; override; stdcall;
   // IODRSObject members
    function EnumODR(var EnumODR: IEnumODR): HResult; override; stdcall;
  end;

  IBaseEnumODR = class(IEnumODR)
  private
    m_cRef: Longint;
    m_iCur: Longint;
    p_Curr: pexProcRec;
  public
    Constructor Create;
    Destructor Destroy; override;
   //IUnknown members
    function QueryInterface(const iid: TIID; var obj): HResult; override; stdcall;
    function AddRef: Longint;  override; stdcall;
    function Release: Longint; override; stdcall;
   // IEnumODR members
    function Next(celt: Longint; var elt;
      pceltFetched: PLongint): HResult; override; stdcall;
    function Skip(celt: Longint): HResult; override; stdcall;
    function Reset: HResult; override; stdcall;
    function Clone(var enum: IEnumODR): HResult; override; stdcall;
  end;

Var
  ObjCount : Integer = 0;

implementation

{ helper functions }

function UnkQueryInterface(Unk: IUnknown; Const UnkIID: TIID; const iid: TIID; var obj): HResult;
begin
  IUnknown(Obj) := NIL;
  if IsequalIID(iid,IID_IUnknown) OR
     IsequalIID(iid,UnkIID)
  then IUnknown(obj) := Unk;
  if IUnknown(obj) <> NIL then begin
    IUnknown(obj).AddRef;
    Result := S_OK;
  end else Result := E_NOINTERFACE;
end;

function UnkAddRef(VAR m_cRef: Longint):Longint;
begin
  Inc(m_cRef);
  Result := m_cRef;
end;

function UnkRelease(Unk: IUnknown; VAR m_cRef: Longint): Longint;
begin
  Dec(m_cRef);
  Result := m_cRef;
  if m_cRef = 0 then Unk.free;
end;

{ IBaseODRSObject }

Constructor IBaseODRSObject.Create;
begin
  Inc(ObjCount);
end;
Destructor IBaseODRSObject.Destroy;
begin
  Dec(ObjCount);
end;


function IBaseODRSObject.QueryInterface;
begin
  Result := UnkQueryInterface(Self,IID_IODRSObject,iid,obj)
end;
function IBaseODRSObject.AddRef;
begin
  Result := UnkAddRef(m_cRef);
end;
function IBaseODRSObject.Release;
begin
  Result := UnkRelease(Self,m_cRef);
end;

function IBaseODRSObject.EnumODR(var EnumODR: IEnumODR): HResult;
begin
  Try
    EnumODR := IBaseEnumODR.Create;
    EnumODR.AddRef;
    Result := S_OK;
  Except
    Result := E_OUTOFMEMORY;
  End;
end;

{ IBaseEnumODR }

Constructor IBaseEnumODR.Create;
begin
  p_Curr := RootUserPtr;
  Inc(ObjCount);
end;
Destructor IBaseEnumODR.Destroy;
begin
  Dec(ObjCount);
end;

function IBaseEnumODR.QueryInterface;
begin
  Result := UnkQueryInterface(Self,IID_IEnumODR,iid,obj)
end;
function IBaseEnumODR.AddRef;
begin
  Result := UnkAddRef(m_cRef);
end;
function IBaseEnumODR.Release;
begin
  Result := UnkRelease(Self,m_cRef);
end;

Type
  tPtrArray = array [0..(maxint div SizeOf(Pointer))-1] of Pointer;

function IBaseEnumODR.Next(celt: Longint; var elt;
      pceltFetched: PLongint): HResult;
VAR cReturn:Longint;
begin
  cReturn:=0;
  Result := E_POINTER;
  if (NIL=pceltFetched) then begin
    if (1 <> Celt) then exit;
  end else pceltFetched^ := 0;
  Result := S_FALSE;
  if (m_iCur >= TotalODR) then exit;
  while (m_iCur < TotalODR) AND (celt > 0) do begin
    tPtrArray(Elt)[cReturn] := p_Curr;
    p_Curr := pexProcRec(p_Curr.UserPtr);
    inc(m_iCur);
    inc(cReturn);
    Dec(celt);
  end;
  if NIL <> pceltFetched then pceltFetched^ := cReturn;
  Result := S_OK;
end;

function IBaseEnumODR.Skip;
begin
  if ((m_iCur+celt) >= TotalODR) then Result := S_FALSE
  else begin
    While celt > 0 do begin
      inc(m_iCur);
      p_Curr := pexProcRec(p_Curr.UserPtr);
      dec(celt);
    end;
    Result :=  S_OK;
  end;
end;

function IBaseEnumODR.Reset;
begin
  m_iCur := 0;
  p_Curr := RootUserPtr;
  Result :=  S_OK;
end;

function IBaseEnumODR.Clone;
VAR
  pNew: IBaseEnumODR;
begin
  Enum:=NIL;
  pNew:= IBaseEnumODR.Create;
  if (NIL<>pNew) then begin
    pNew.m_iCur:=m_iCur;
    pNew.p_Curr := p_Curr;
    pNew.AddRef;
  end;
  Enum:=pNew;
  Result := S_OK;
end;


end.
