{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit ODRSVars;
{$I ..\alldemo.inc}

interface  uses Windows,Sysutils,ActiveX,PARSEH;


VAR
{ Following variables should be initialised during module startup }

  RootUserPtr: pexProcRec = NIL;  { Root of the linked list of the Operation Definition Records.
                                    Records are linked through the texprocrec.UserPtr member }
  TotalODR   : Longint = 0;       { Total number of Records in the linked list }

  ExServer_LICKEY : string; { License key for the object - the first line of the global license file
                              Module_Name.LIC located in the folder containing DLL }
  machinelicensed : Boolean; {<- initialized via QueryMachineLicensed call }

Procedure QueryMachineLicensed;
{ Helper function for the IClassfactory2 licensing scheme

  Procedure checks for the presence of the global license file
  and compares its first line with the (decoded) ExServer_LICKEY string value
  that was assigned during module initialization.
  If they compare OK, the machine is globally licensed and the
  MachineLicensed global variable becomes TRUE.
  Call this procedure during the module initialization after the
  ExServer_LICKEY was assigned a value }

{ some simple string encryption/decryption utilities }
Function EncodeStr(const s: string): string;
Function DecodeStr(const s: string): string;


implementation

Function EncodeStr(const s: string): string;
var i: integer;
begin
  Result := '';
  for i := 1 to length(s) div 2 do begin
    Result := Result + succ(s[2*i])+succ(s[2*i-1])+char(ord(' ')+(i mod 255));
  end;
  if odd(length(s)) then Result := Result+succ(s[length(s)])
end;
Function DecodeStr(const s: string): string;
var i: integer;
begin
  Result := '';
  for i := 1 to length(s) div 3 do begin
    Result := Result + pred(s[i*3-1])+pred(s[i*3-2]);
  end;
  if (length(s) mod 3) <> 0  then Result := Result+pred(s[length(s)])
end;

Procedure QueryMachineLicensed;
var mpath: array [0..Max_Path] of char;
    s: string;
    txt: text;
begin
  machinelicensed := false;
  if GetModuleFilename(hInstance,mpath,Max_Path) > 0 then begin
    s := ChangeFileExt(mpath,'.LIC');
    if FileExists(s) then TRY
      assignFile(txt,s);
      reset(txt);
      Try
        s := '';
        if not eof(txt) then Readln(txt,s);
        MachineLicensed := s=ExServer_LICKEY;
      Finally
        closefile(txt);
      End
    except
      { all handled }
    end;
  end;
end;

VAR
  OLEInitialized: Boolean;

Initialization
  OLEInitialized :=  succeeded(OleInitialize(NIL))

Finalization
  if OLEInitialized then OleUninitialize;

end.
