{=================================================================
 EXPARSE  Copyright 1996..1999 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
==================================================================}

unit SrvObj;
{$I ..\alldemo.inc}

interface
Uses Windows,Sysutils,ACtiveX,ComObj,
     ParseH,
     ODRSH, ODRSVars;

Type


  TLicComObjectFactory=class(TComObjectFactory)
{ As we do use Iclassfactory2 licensing, we have to tell whether
  the machine has global license }
  protected
    function HasMachineLicense: Boolean; override;
  end;

  TBaseODRSObject = class(tComObject,IODRSObject)
   // IODRSObject members
    function EnumODR(out EnumODR: IEnumODR): HResult; stdcall;
  end;

  TBaseEnumODR = class(tInterfacedObject,IEnumODR)
  private
    m_iCur: Longint;
    p_Curr: pexProcRec;
  public
    Constructor Create;
   // IEnumODR members
    function Next(celt: integer; out elt; pceltFetched: pointer): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enum: IEnumODR): HResult; stdcall;
  end;

implementation


 { TLicComObjectFactory }
function TLicComObjectFactory.HasMachineLicense: Boolean;
begin
  result := machinelicensed;
end;


{ TBaseODRSObject }

function TBaseODRSObject.EnumODR(out EnumODR: IEnumODR): HResult;
begin
  TRY
    EnumODR := TBaseEnumODR.Create;
    EnumODR._AddRef;
    Result := S_OK;
  EXCEPT
    Result := E_OUTOFMEMORY;
  END
end;

{ IBaseEnumODR }

Constructor TBaseEnumODR.Create;
begin
  inherited Create;
  p_Curr := RootUserPtr;
end;

Type
  tPtrArray = array [0..(maxint div SizeOf(Pointer))-1] of Pointer;

function TBaseEnumODR.Next;
VAR cReturn:Longint;
begin
  cReturn:=0;
  Result := E_POINTER;
  if (NIL=pceltFetched) then begin
    if (1 <> Celt) then exit;
  end else longint(pceltFetched^) := 0;
  Result := S_FALSE;
  if (m_iCur >= TotalODR) then exit;
  while (m_iCur < TotalODR) AND (celt > 0) do begin
    tPtrArray(Elt)[cReturn] := p_Curr;
    p_Curr := pexProcRec(p_Curr.UserPtr);
    inc(m_iCur);
    inc(cReturn);
    Dec(celt);
  end;
  if NIL <> pceltFetched then longint(pceltFetched^) := cReturn;
  Result := S_OK;
end;

function TBaseEnumODR.Skip;
begin
  if ((m_iCur+celt) >= TotalODR) then Result := S_FALSE
  else begin
    While celt > 0 do begin
      inc(m_iCur);
      p_Curr := pexProcRec(p_Curr.UserPtr);
      dec(celt);
    end;
    Result :=  S_OK;
  end;  
end;

function TBaseEnumODR.Reset;
begin
  m_iCur := 0;
  p_Curr := RootUserPtr;
  Result :=  S_OK;
end;

function TBaseEnumODR.Clone;
VAR
  pNew: TBaseEnumODR;
begin
  Enum:=NIL;
  pNew:= TBaseEnumODR.Create;
  if (NIL<>pNew) then begin
    pNew.m_iCur:=m_iCur;
    pNew.p_Curr := p_Curr;
    pNew._AddRef;
  end;
  Enum:=pNew;
  Result := S_OK;
end;


end.
